(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory(require("react"), require("react-native"));
	else if(typeof define === 'function' && define.amd)
		define([, "react-native"], factory);
	else if(typeof exports === 'object')
		exports["fefea8ec8049aa2094a1"] = factory(require("react"), require("react-native"));
	else
		root["fefea8ec8049aa2094a1"] = factory(root["React"], root["react-native"]);
})(self, (__WEBPACK_EXTERNAL_MODULE_react__, __WEBPACK_EXTERNAL_MODULE_react_native__) => {
return /******/ (() => { // webpackBootstrap
/******/ 	var __webpack_modules__ = ({

/***/ "./node_modules/@agora-rte/rte-controller-base/lib/index.js":
/*!******************************************************************!*\
  !*** ./node_modules/@agora-rte/rte-controller-base/lib/index.js ***!
  \******************************************************************/
/***/ (function(module) {

(function webpackUniversalModuleDefinition(root, factory) {
	if(true)
		module.exports = factory();
	else {}
})(this, () => {
return /******/ (() => { // webpackBootstrap
/******/ 	var __webpack_modules__ = ({

/***/ "./src/common.ts":
/*!***********************!*\
  !*** ./src/common.ts ***!
  \***********************/
/***/ ((__unused_webpack_module, __webpack_exports__, __nested_webpack_require_631__) => {

"use strict";
__nested_webpack_require_631__.r(__webpack_exports__);
/* harmony export */ __nested_webpack_require_631__.d(__webpack_exports__, {
/* harmony export */   "isStringEmpty": () => (/* binding */ isStringEmpty),
/* harmony export */   "rteGetAbsoluteUri": () => (/* binding */ rteGetAbsoluteUri)
/* harmony export */ });
/**
 *
 * Agora Real Time Engagement
 * Created by Wei Hu in 2022-04.
 * Copyright (c) 2022 Agora IO. All rights reserved.
 *
 */

/**
 * Construct an absolute uri when the web UI widget needs to get some more
 * resources from the RTE module.
 *
 * @param baseUri exp: "http://127.0.0.1:8001/1/1/"
 * @param relativePath exp: "c/d/e/index.js" | "/c/d/e/index.js"
 * @returns "http://127.0.0.1:8001/1/1/c/d/e/index.js"
 */
function rteGetAbsoluteUri(baseUri, relativePath, isLocalDevEnv) {
  var isBase64 = relativePath.includes('data:image/jpeg;base64');

  if (isLocalDevEnv || isBase64) {
    return relativePath;
  }

  var connector = '/';
  var newBaseUri = baseUri;
  var newSourceUri = relativePath.replace(/^\.+/, '');

  if (/^\//.test(relativePath)) {
    newSourceUri = relativePath.slice(1);
  }

  if (/\/$/.test(baseUri)) {
    newBaseUri = baseUri.slice(0, -1);
  }

  return "".concat(newBaseUri).concat(connector).concat(newSourceUri);
}
function isStringEmpty(value) {
  return !value || value === '';
}

/***/ }),

/***/ "./src/context.ts":
/*!************************!*\
  !*** ./src/context.ts ***!
  \************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __nested_webpack_require_2172__) => {

"use strict";
__nested_webpack_require_2172__.r(__webpack_exports__);
/* harmony export */ __nested_webpack_require_2172__.d(__webpack_exports__, {
/* harmony export */   "RteContext": () => (/* binding */ RteContext),
/* harmony export */   "createDefaultRteContext": () => (/* binding */ createDefaultRteContext),
/* harmony export */   "getGlobalRteContext": () => (/* binding */ getGlobalRteContext),
/* harmony export */   "registerRteContextAsGlobal": () => (/* binding */ registerRteContextAsGlobal)
/* harmony export */ });
/* harmony import */ var _babel_runtime_helpers_classCallCheck__WEBPACK_IMPORTED_MODULE_0__ = __nested_webpack_require_2172__(/*! @babel/runtime/helpers/classCallCheck */ "./node_modules/@babel/runtime/helpers/esm/classCallCheck.js");
/* harmony import */ var _babel_runtime_helpers_createClass__WEBPACK_IMPORTED_MODULE_1__ = __nested_webpack_require_2172__(/*! @babel/runtime/helpers/createClass */ "./node_modules/@babel/runtime/helpers/esm/createClass.js");
/* harmony import */ var _babel_runtime_regenerator__WEBPACK_IMPORTED_MODULE_2__ = __nested_webpack_require_2172__(/*! @babel/runtime/regenerator */ "./node_modules/@babel/runtime/regenerator/index.js");
/* harmony import */ var _babel_runtime_regenerator__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__nested_webpack_require_2172__.n(_babel_runtime_regenerator__WEBPACK_IMPORTED_MODULE_2__);
/* harmony import */ var _common__WEBPACK_IMPORTED_MODULE_3__ = __nested_webpack_require_2172__(/*! ./common */ "./src/common.ts");
/* harmony import */ var _http__WEBPACK_IMPORTED_MODULE_4__ = __nested_webpack_require_2172__(/*! ./http */ "./src/http.ts");
/* harmony import */ var _logger__WEBPACK_IMPORTED_MODULE_5__ = __nested_webpack_require_2172__(/*! ./logger */ "./src/logger.ts");
/* harmony import */ var _rte__WEBPACK_IMPORTED_MODULE_6__ = __nested_webpack_require_2172__(/*! ./rte */ "./src/rte.ts");
/* harmony import */ var _websocket__WEBPACK_IMPORTED_MODULE_7__ = __nested_webpack_require_2172__(/*! ./websocket */ "./src/websocket.ts");
/* harmony import */ var _widget_props__WEBPACK_IMPORTED_MODULE_8__ = __nested_webpack_require_2172__(/*! ./widget_props */ "./src/widget_props.ts");



function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (!it) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }



var __awaiter =  false || function (thisArg, _arguments, P, generator) {
  function adopt(value) {
    return value instanceof P ? value : new P(function (resolve) {
      resolve(value);
    });
  }

  return new (P || (P = Promise))(function (resolve, reject) {
    function fulfilled(value) {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    }

    function rejected(value) {
      try {
        step(generator["throw"](value));
      } catch (e) {
        reject(e);
      }
    }

    function step(result) {
      result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected);
    }

    step((generator = generator.apply(thisArg, _arguments || [])).next());
  });
};







var RteContext = /*#__PURE__*/function () {
  function RteContext(gatewayLoc) {
    (0,_babel_runtime_helpers_classCallCheck__WEBPACK_IMPORTED_MODULE_0__["default"])(this, RteContext);

    // Default options.
    this._options = {
      appReadyTimeout: 10,
      appReadyCheckPeriod: 300,
      notifyMessageChannelNotReadyTimeout: 10,
      enableProfiling: false
    };
    this._isReadyState = false;
    this._isClosedState = false;
    this._isReadyToReceiveExtensionMessageCalled = false;
    this._subscriptions = [];
    this.gatewayLoc = gatewayLoc;

    if (!gatewayLoc.uri || gatewayLoc.uri === '') {
      this.gatewayLoc.uri = 'localhost';
    }
  }

  (0,_babel_runtime_helpers_createClass__WEBPACK_IMPORTED_MODULE_1__["default"])(RteContext, [{
    key: "initContext",
    value: function initContext(option) {
      return __awaiter(this, void 0, void 0, /*#__PURE__*/_babel_runtime_regenerator__WEBPACK_IMPORTED_MODULE_2___default().mark(function _callee() {
        var _this = this;

        return _babel_runtime_regenerator__WEBPACK_IMPORTED_MODULE_2___default().wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                if (option) {
                  Object.assign(this._options, option);
                }

                _logger__WEBPACK_IMPORTED_MODULE_5__.info('Try to create the message channel..');
                _context.next = 4;
                return this.createMessageChannel();

              case 4:
                _logger__WEBPACK_IMPORTED_MODULE_5__.info("Success to create the message channel, ".concat(this._exportedRte));

                if (this.isLocalEnv()) {
                  // rte-controller and the RTE App is running in the same thread, we
                  // register RteContext to global, then the extension can get it.
                  registerRteContextAsGlobal(this);
                }

                this._isReadyState = true;
                setTimeout(function () {
                  var _a;

                  if (_this._isReadyToReceiveExtensionMessageCalled) {
                    return;
                  }

                  var unReadyWidgets = (_a = _this.rteUiWidgetList) === null || _a === void 0 ? void 0 : _a.widgets.filter(function (widget) {
                    return widget.isReady === false;
                  }).map(function (widget) {
                    return widget.extension;
                  });
                  _logger__WEBPACK_IMPORTED_MODULE_5__.warn("The message channel is not ready after ".concat(_this._options.notifyMessageChannelNotReadyTimeout, " seconds. All widgets can receive messages from the extensions only after the message channel is ready. \n\nThose widgets[").concat(unReadyWidgets, "] are not ready."));
                }, this._options.notifyMessageChannelNotReadyTimeout * 1000);

              case 8:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));
    }
  }, {
    key: "dispatchWidgetMessage",
    value: function dispatchWidgetMessage(message) {
      if (!this._isReadyState) {
        throw new Error("RteContext is not ready, call 'initContext()' first.");
      }

      if (this._isClosedState) {
        throw new Error("RteContext is closed.");
      }

      var _iterator = _createForOfIteratorHelper(this._subscriptions),
          _step;

      try {
        for (_iterator.s(); !(_step = _iterator.n()).done;) {
          var subscription = _step.value;

          if (subscription.extension_group && subscription.extension_group !== message.extension_group) {
            continue;
          }

          if (subscription.extension && subscription.extension !== message.extension) {
            continue;
          }

          if (subscription.type && subscription.type !== message.type) {
            continue;
          }

          subscription.handler(message);
        }
      } catch (err) {
        _iterator.e(err);
      } finally {
        _iterator.f();
      }

      if (this.rteUiWidgetList) {
        // There maybe more than one widget which has the same extension name, so
        // we cannot use map here.
        var _iterator2 = _createForOfIteratorHelper(this.rteUiWidgetList.widgets),
            _step2;

        try {
          for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
            var uiWidget = _step2.value;

            if (message.extension_group !== uiWidget.extension_group) {
              continue;
            }

            if (message.extension !== uiWidget.extension) {
              continue;
            }

            if (this._options.enableProfiling) {
              this.updateWidgetProfiling(uiWidget, 'receive-first-msg');
            }

            var _iterator3 = _createForOfIteratorHelper(uiWidget.rteUiWidgetMsgHandlers),
                _step3;

            try {
              for (_iterator3.s(); !(_step3 = _iterator3.n()).done;) {
                var handler = _step3.value;
                handler(message);
              }
            } catch (err) {
              _iterator3.e(err);
            } finally {
              _iterator3.f();
            }
          }
        } catch (err) {
          _iterator2.e(err);
        } finally {
          _iterator2.f();
        }
      }
    }
    /**
     * Send request to RTE Extension from a UI Widget or Host APP.
     *
     * @param request The request must follow the RTE Cmd Spec, and the 'command'
     *                cannot be 'status'.
     * @param widget You can specify the widget info if the request is sent from
     *               UI widget. And the destination will be the UI extension if
     *               the 'dest' of request is null.
     * @param useHttpPost If the RTE App is running as HTTP Server, you can send a
     *                    POST request if 'useHttpPost' is true. Otherwise, the
     *                    request will be sent by websocket.
     */

  }, {
    key: "sendRequestToRteExtension",
    value: function sendRequestToRteExtension(request, widget) {
      var useHttpPost = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;
      return __awaiter(this, void 0, void 0, /*#__PURE__*/_babel_runtime_regenerator__WEBPACK_IMPORTED_MODULE_2___default().mark(function _callee2() {
        var data, status;
        return _babel_runtime_regenerator__WEBPACK_IMPORTED_MODULE_2___default().wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                _logger__WEBPACK_IMPORTED_MODULE_5__.info("sendRequestToRteExtension, ".concat(JSON.stringify(request)));

                if (this._isReadyState) {
                  _context2.next = 3;
                  break;
                }

                throw new Error("RteContext is not ready, call 'initContext()' first.");

              case 3:
                if (!this._isClosedState) {
                  _context2.next = 5;
                  break;
                }

                throw new Error("RteContext is closed.");

              case 5:
                if (!request.dest || request.dest.length === 0) {
                  request.dest = widget ? [widget] : [this.gatewayLoc];
                }

                if (!this._ws) {
                  _context2.next = 16;
                  break;
                }

                if (!useHttpPost) {
                  _context2.next = 12;
                  break;
                }

                _context2.next = 10;
                return (0,_http__WEBPACK_IMPORTED_MODULE_4__.rteHttpPost)(this.gatewayLoc.uri, request).then(function (res) {
                  return res.parsedBody;
                });

              case 10:
                data = _context2.sent;
                return _context2.abrupt("return", data);

              case 12:
                this._ws.send(JSON.stringify(request));

                return _context2.abrupt("return", undefined);

              case 16:
                if (!this._exportedRte) {
                  _context2.next = 31;
                  break;
                }

                _logger__WEBPACK_IMPORTED_MODULE_5__.info("Send request with exportedRte, ".concat(JSON.stringify(request)));
                _context2.next = 20;
                return this._exportedRte.sendJson(request);

              case 20:
                status = _context2.sent;
                _logger__WEBPACK_IMPORTED_MODULE_5__.info("Response to ".concat(request.command, ": ").concat(JSON.stringify(status)));

                if (!(status.status_code !== 'ok')) {
                  _context2.next = 24;
                  break;
                }

                throw new Error("The response to ".concat(request.command, " is error, detail:\n          ").concat(status.detail));

              case 24:
                _context2.prev = 24;
                return _context2.abrupt("return", JSON.parse(status.detail));

              case 28:
                _context2.prev = 28;
                _context2.t0 = _context2["catch"](24);
                return _context2.abrupt("return", status.detail);

              case 31:
                throw new Error("There is no available message channel between Host and RTE Extension.");

              case 32:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this, [[24, 28]]);
      }));
    }
  }, {
    key: "sendCmdToRteExtension",
    value: function sendCmdToRteExtension(request) {
      return __awaiter(this, void 0, void 0, /*#__PURE__*/_babel_runtime_regenerator__WEBPACK_IMPORTED_MODULE_2___default().mark(function _callee3() {
        var data, status;
        return _babel_runtime_regenerator__WEBPACK_IMPORTED_MODULE_2___default().wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                if (this._isReadyState) {
                  _context3.next = 2;
                  break;
                }

                throw new Error("RteContext is not ready, call 'initContext()' first.");

              case 2:
                if (!this._isClosedState) {
                  _context3.next = 4;
                  break;
                }

                throw new Error("RteContext is closed.");

              case 4:
                if (!this._ws) {
                  _context3.next = 11;
                  break;
                }

                _context3.next = 7;
                return (0,_http__WEBPACK_IMPORTED_MODULE_4__.rteHttpPost)(this.gatewayLoc.uri, request.toJson()).then(function (res) {
                  return res.parsedBody;
                });

              case 7:
                data = _context3.sent;
                return _context3.abrupt("return", data);

              case 11:
                if (!this._exportedRte) {
                  _context3.next = 24;
                  break;
                }

                _context3.next = 14;
                return this._exportedRte.sendCmd(request);

              case 14:
                status = _context3.sent;

                if (!(status.status_code !== 'ok')) {
                  _context3.next = 17;
                  break;
                }

                throw new Error("The response to ".concat(request.command, " is error, detail:\n          ").concat(status.detail));

              case 17:
                _context3.prev = 17;
                return _context3.abrupt("return", JSON.parse(status.detail));

              case 21:
                _context3.prev = 21;
                _context3.t0 = _context3["catch"](17);
                return _context3.abrupt("return", status.detail);

              case 24:
                throw new Error("There is no available message channel between Host and RTE Extension.");

              case 25:
              case "end":
                return _context3.stop();
            }
          }
        }, _callee3, this, [[17, 21]]);
      }));
    }
    /**
     * It's time to open the bidirectional channel between the App and RTE
     * extensions, and will start to receive messages from RTE Extensions.
     *
     * N.B.: This method can only be called once.
     */

  }, {
    key: "readyToReceiveExtensionMessage",
    value: function readyToReceiveExtensionMessage() {
      if (this._isReadyToReceiveExtensionMessageCalled) {
        _logger__WEBPACK_IMPORTED_MODULE_5__.warn('This method can only be called once.');
        return;
      }

      if (this._isClosedState) {
        throw new Error("RteContext is closed.");
      }

      _logger__WEBPACK_IMPORTED_MODULE_5__.info('All widgets are ready, open bidirectional channel.');

      if (this.rteUiWidgetList && this._options.enableProfiling) {
        var _iterator4 = _createForOfIteratorHelper(this.rteUiWidgetList.widgets),
            _step4;

        try {
          for (_iterator4.s(); !(_step4 = _iterator4.n()).done;) {
            var widget = _step4.value;
            this.updateWidgetProfiling(widget, 'receive-first-msg');
          }
        } catch (err) {
          _iterator4.e(err);
        } finally {
          _iterator4.f();
        }
      }

      this._isReadyToReceiveExtensionMessageCalled = true;
      (0,_rte__WEBPACK_IMPORTED_MODULE_6__.openBidirectionalChannelToRte)(this);
    }
    /**
     * Set a user defined callback to receive the binding event of the ui widget.
     * The App can customize the timing of opening the message channel between the
     * App and RTE Extension.
     *
     * N.B.: keep in mind that you have to call the
     * 'readyToReceiveExtensionMessage()' method, which will start to receive
     * message from RTE Extension.
     *
     * @param listener
     */

  }, {
    key: "setWidgetMountedListener",
    value: function setWidgetMountedListener(listener) {
      this._onWidgetMounted = listener;
    }
    /**
     * Subscribe the extension event outside of the Ui Widget.
     *
     * @param subscription you have to specify 'type' or 'extension', or both.
     * @throws invalid parameter error
     */

  }, {
    key: "subscribeEvent",
    value: function subscribeEvent(subscription) {
      if ((0,_common__WEBPACK_IMPORTED_MODULE_3__.isStringEmpty)(subscription.type) && (0,_common__WEBPACK_IMPORTED_MODULE_3__.isStringEmpty)(subscription.extension)) {
        throw new Error("Neither 'type' nor 'extension' was specified.");
      }

      this._subscriptions.push(subscription);
    }
    /**
     * @param subscription you have to specify 'type' or 'extension', or both.
     * @throws invalid parameter error
     */

  }, {
    key: "unsubscribeEvent",
    value: function unsubscribeEvent(subscription) {
      if ((0,_common__WEBPACK_IMPORTED_MODULE_3__.isStringEmpty)(subscription.type) && (0,_common__WEBPACK_IMPORTED_MODULE_3__.isStringEmpty)(subscription.extension)) {
        throw new Error("Neither 'type' nor 'extension' was specified.");
      }

      var index = this._subscriptions.indexOf(subscription);

      if (index !== -1) {
        this._subscriptions.splice(index, 1);
      }
    }
  }, {
    key: "onWidgetReady",
    value: function onWidgetReady(widget, error) {
      this.submitProfilingEvent(widget.extension, widget.extension_group, 'mount-widget');
      this.submitProfilingEvent(widget.extension, widget.extension_group, 'render-extension-container');

      if (this._onWidgetMounted) {
        // We will use 'isReady' to detect whether all the widgets are ready.
        widget.isReady = true; // Call the user defined listener first.

        this._onWidgetMounted(this, widget, error);

        return;
      }

      if (widget.isReady) {
        // This method will be called when the widget is mounted and re-mounted.
        // But the message channel only needs to be opened once. So we will drop
        // the remount event.
        return;
      }

      widget.isReady = true;
      var allReady = true;

      if (this.rteUiWidgetList) {
        var _iterator5 = _createForOfIteratorHelper(this.rteUiWidgetList.widgets),
            _step5;

        try {
          for (_iterator5.s(); !(_step5 = _iterator5.n()).done;) {
            var uiWidgetInfo = _step5.value;

            if (uiWidgetInfo.isReady === false) {
              allReady = false;
              break;
            }
          }
        } catch (err) {
          _iterator5.e(err);
        } finally {
          _iterator5.f();
        }
      }

      if (allReady === true) {
        _logger__WEBPACK_IMPORTED_MODULE_5__.info('All widgets are ready.');
        this.readyToReceiveExtensionMessage();
      }
    }
    /**
     * Release RteContext before stopping the RTE App.
     */

  }, {
    key: "release",
    value: function release() {
      this._isClosedState = true;

      if (this._ws) {
        this._ws.close(1000
        /* normal close */
        );

        this._ws = undefined;
      }
    }
  }, {
    key: "submitProfilingEvent",
    value: function submitProfilingEvent(extension, extension_group, phase) {
      var _a;

      if (!this._options.enableProfiling) {
        return;
      }

      var widgetInfo = (_a = this.rteUiWidgetList) === null || _a === void 0 ? void 0 : _a.widgets.find(function (value) {
        return value.extension === extension && value.extension_group === extension_group;
      });

      if (!widgetInfo) {
        return;
      }

      this.updateWidgetProfiling(widgetInfo, phase);
    }
  }, {
    key: "getWidgetProfiling",
    value: function getWidgetProfiling(extension, extension_group) {
      var _a;

      if (!this._options.enableProfiling) {
        throw new Error('Enable profiling in RteContext first!');
      }

      var widgetInfo = (_a = this.rteUiWidgetList) === null || _a === void 0 ? void 0 : _a.widgets.find(function (value) {
        return value.extension === extension && value.extension_group === extension_group;
      });

      if (widgetInfo) {
        return widgetInfo.profilingEvents;
      }

      throw new Error("The extension[".concat(extension, "] is not found in the widget list!"));
    }
  }, {
    key: "updateWidgetProfiling",
    value: function updateWidgetProfiling(widgetInfo, phase) {
      var now = Date.now();
      var profiling = widgetInfo.profilingEvents.find(function (value) {
        return value.phase === phase;
      });

      if (profiling) {
        if (profiling.commitTime > 0) {
          return;
        }

        profiling.commitTime = now;
        profiling.duration = profiling.commitTime - profiling.startTime;

        if (this._options.onProfilingEvent) {
          this._options.onProfilingEvent(profiling);
        }
      } else {
        widgetInfo.profilingEvents.push({
          extension: widgetInfo.extension,
          extension_group: widgetInfo.extension_group,
          phase: phase,
          startTime: now,
          commitTime: 0,
          duration: 0
        });
      }
    }
  }, {
    key: "createMessageChannel",
    value: function createMessageChannel() {
      return __awaiter(this, void 0, void 0, /*#__PURE__*/_babel_runtime_regenerator__WEBPACK_IMPORTED_MODULE_2___default().mark(function _callee4() {
        return _babel_runtime_regenerator__WEBPACK_IMPORTED_MODULE_2___default().wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                if (!(this.gatewayLoc.uri === 'localhost')) {
                  _context4.next = 6;
                  break;
                }

                _context4.next = 3;
                return (0,_rte__WEBPACK_IMPORTED_MODULE_6__.getExportedRte)(this.gatewayLoc.extension, this.gatewayLoc.extension_group, this._options.appReadyTimeout);

              case 3:
                this._exportedRte = _context4.sent;
                _context4.next = 15;
                break;

              case 6:
                if (!this.gatewayLoc.uri.startsWith('http://')) {
                  _context4.next = 14;
                  break;
                }

                _context4.next = 9;
                return (0,_websocket__WEBPACK_IMPORTED_MODULE_7__.checkWsConnection)(this.gatewayLoc.uri, this._options.appReadyCheckPeriod, this._options.appReadyTimeout);

              case 9:
                _context4.next = 11;
                return (0,_websocket__WEBPACK_IMPORTED_MODULE_7__.connectToRteAppThroughWebsocket)(this);

              case 11:
                this._ws = _context4.sent;
                _context4.next = 15;
                break;

              case 14:
                throw new Error("Could not create the message channel with uri[".concat(this.gatewayLoc.uri, "],\n        the uri should be 'localhost' or start with 'http://'."));

              case 15:
              case "end":
                return _context4.stop();
            }
          }
        }, _callee4, this);
      }));
    }
  }, {
    key: "isLocalEnv",
    value: function isLocalEnv() {
      return this.gatewayLoc.uri === 'localhost';
    }
  }]);

  return RteContext;
}();
function registerRteContextAsGlobal(rteContext) {
  var done = false;

  if (window) {
    // eslint-disable-next-line @typescript-eslint/no-explicit-any
    window.rteContext = rteContext;
    done = true;
  }

  if (__nested_webpack_require_2172__.g) {
    // eslint-disable-next-line @typescript-eslint/no-explicit-any
    __nested_webpack_require_2172__.g.rteContext = rteContext;
    done = true;
  }

  if (!done) {
    throw new Error('Failed to register rte-context to global scope.');
  }
}
function getGlobalRteContext() {
  if (window) {
    // eslint-disable-next-line @typescript-eslint/no-explicit-any
    var _window = window,
        rteContext = _window.rteContext;

    if (rteContext) {
      return rteContext;
    }
  }

  if (__nested_webpack_require_2172__.g) {
    // eslint-disable-next-line @typescript-eslint/no-explicit-any
    var _global = __nested_webpack_require_2172__.g,
        _rteContext = _global.rteContext;

    if (_rteContext) {
      return _rteContext;
    }
  }

  return undefined;
}
/**
 * Create the RteContext instance.
 *
 * @param gateway The loc info of the ui gateway extension. If the RTE App is
 * running in the rendering thread, the 'uri' should be 'localhost' or empty.
 *
 * @returns
 */

function createDefaultRteContext(gateway, contextOptions) {
  return __awaiter(this, void 0, void 0, /*#__PURE__*/_babel_runtime_regenerator__WEBPACK_IMPORTED_MODULE_2___default().mark(function _callee5() {
    var rteContext;
    return _babel_runtime_regenerator__WEBPACK_IMPORTED_MODULE_2___default().wrap(function _callee5$(_context5) {
      while (1) {
        switch (_context5.prev = _context5.next) {
          case 0:
            rteContext = new RteContext(gateway);
            _logger__WEBPACK_IMPORTED_MODULE_5__.info('Try to init rte context.');
            _context5.next = 4;
            return rteContext.initContext(contextOptions);

          case 4:
            _logger__WEBPACK_IMPORTED_MODULE_5__.info("Success to init rte context: ".concat(rteContext));
            _context5.next = 7;
            return (0,_widget_props__WEBPACK_IMPORTED_MODULE_8__.getRteUiWidgetList)(rteContext);

          case 7:
            rteContext.rteUiWidgetList = _context5.sent;
            return _context5.abrupt("return", rteContext);

          case 9:
          case "end":
            return _context5.stop();
        }
      }
    }, _callee5);
  }));
}

/***/ }),

/***/ "./src/http.ts":
/*!*********************!*\
  !*** ./src/http.ts ***!
  \*********************/
/***/ ((__unused_webpack_module, __webpack_exports__, __nested_webpack_require_30423__) => {

"use strict";
__nested_webpack_require_30423__.r(__webpack_exports__);
/* harmony export */ __nested_webpack_require_30423__.d(__webpack_exports__, {
/* harmony export */   "rteHttpGet": () => (/* binding */ rteHttpGet),
/* harmony export */   "rteHttpPost": () => (/* binding */ rteHttpPost),
/* harmony export */   "rteHttpPut": () => (/* binding */ rteHttpPut)
/* harmony export */ });
/* harmony import */ var _babel_runtime_regenerator__WEBPACK_IMPORTED_MODULE_0__ = __nested_webpack_require_30423__(/*! @babel/runtime/regenerator */ "./node_modules/@babel/runtime/regenerator/index.js");
/* harmony import */ var _babel_runtime_regenerator__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__nested_webpack_require_30423__.n(_babel_runtime_regenerator__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _logger__WEBPACK_IMPORTED_MODULE_1__ = __nested_webpack_require_30423__(/*! ./logger */ "./src/logger.ts");


var __awaiter =  false || function (thisArg, _arguments, P, generator) {
  function adopt(value) {
    return value instanceof P ? value : new P(function (resolve) {
      resolve(value);
    });
  }

  return new (P || (P = Promise))(function (resolve, reject) {
    function fulfilled(value) {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    }

    function rejected(value) {
      try {
        step(generator["throw"](value));
      } catch (e) {
        reject(e);
      }
    }

    function step(result) {
      result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected);
    }

    step((generator = generator.apply(thisArg, _arguments || [])).next());
  });
};
/**
 *
 * Agora Real Time Engagement
 * Created by Wei Hu in 2022-04.
 * Copyright (c) 2022 Agora IO. All rights reserved.
 *
 */



/**
 * T is the type of the returned body.
 */

function rteHttp(request) {
  return __awaiter(this, void 0, void 0, /*#__PURE__*/_babel_runtime_regenerator__WEBPACK_IMPORTED_MODULE_0___default().mark(function _callee() {
    var response;
    return _babel_runtime_regenerator__WEBPACK_IMPORTED_MODULE_0___default().wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.next = 2;
            return fetch(request);

          case 2:
            response = _context.sent;
            _context.prev = 3;
            _context.next = 6;
            return response.json();

          case 6:
            response.parsedBody = _context.sent;
            _context.next = 12;
            break;

          case 9:
            _context.prev = 9;
            _context.t0 = _context["catch"](3);
            // Continue regardless of error.
            _logger__WEBPACK_IMPORTED_MODULE_1__.warn("The received body is not a json: ".concat(response));

          case 12:
            if (response.ok) {
              _context.next = 14;
              break;
            }

            throw new Error(response.statusText);

          case 14:
            return _context.abrupt("return", response);

          case 15:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, null, [[3, 9]]);
  }));
}
/**
 * Send out a HTTP GET request.
 */


function rteHttpGet(path) {
  var args = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {
    method: 'get',
    mode: 'cors',
    headers: {
      'Content-Type': 'application/json'
    }
  };
  return __awaiter(this, void 0, void 0, /*#__PURE__*/_babel_runtime_regenerator__WEBPACK_IMPORTED_MODULE_0___default().mark(function _callee2() {
    return _babel_runtime_regenerator__WEBPACK_IMPORTED_MODULE_0___default().wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            _context2.next = 2;
            return rteHttp(new Request(path, args));

          case 2:
            return _context2.abrupt("return", _context2.sent);

          case 3:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2);
  }));
}
/**
 * Send out a HTTP POST request.
 */

function rteHttpPost(path, body) {
  var args = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {
    method: 'post',
    mode: 'cors',
    headers: {
      'Content-Type': 'application/json'
    },
    body: JSON.stringify(body)
  };
  return __awaiter(this, void 0, void 0, /*#__PURE__*/_babel_runtime_regenerator__WEBPACK_IMPORTED_MODULE_0___default().mark(function _callee3() {
    return _babel_runtime_regenerator__WEBPACK_IMPORTED_MODULE_0___default().wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            _context3.next = 2;
            return rteHttp(new Request(path, args));

          case 2:
            return _context3.abrupt("return", _context3.sent);

          case 3:
          case "end":
            return _context3.stop();
        }
      }
    }, _callee3);
  }));
}
/**
 * Send out a HTTP PUT request.
 */

function rteHttpPut(path, body) {
  var args = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {
    method: 'put',
    mode: 'cors',
    headers: {
      'Content-Type': 'application/json'
    },
    body: JSON.stringify(body)
  };
  return __awaiter(this, void 0, void 0, /*#__PURE__*/_babel_runtime_regenerator__WEBPACK_IMPORTED_MODULE_0___default().mark(function _callee4() {
    return _babel_runtime_regenerator__WEBPACK_IMPORTED_MODULE_0___default().wrap(function _callee4$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            _context4.next = 2;
            return rteHttp(new Request(path, args));

          case 2:
            return _context4.abrupt("return", _context4.sent);

          case 3:
          case "end":
            return _context4.stop();
        }
      }
    }, _callee4);
  }));
}

/***/ }),

/***/ "./src/logger.ts":
/*!***********************!*\
  !*** ./src/logger.ts ***!
  \***********************/
/***/ ((__unused_webpack_module, __webpack_exports__, __nested_webpack_require_36570__) => {

"use strict";
__nested_webpack_require_36570__.r(__webpack_exports__);
/* harmony export */ __nested_webpack_require_36570__.d(__webpack_exports__, {
/* harmony export */   "error": () => (/* binding */ error),
/* harmony export */   "info": () => (/* binding */ info),
/* harmony export */   "warn": () => (/* binding */ warn)
/* harmony export */ });
/* harmony import */ var _babel_runtime_helpers_toConsumableArray__WEBPACK_IMPORTED_MODULE_0__ = __nested_webpack_require_36570__(/*! @babel/runtime/helpers/toConsumableArray */ "./node_modules/@babel/runtime/helpers/esm/toConsumableArray.js");


/**
 *
 * Agora Real Time Engagement
 * Created by Wei Hu in 2022-05.
 * Copyright (c) 2015 Agora IO. All rights reserved.
 *
 */
function info() {
  for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
    args[_key] = arguments[_key];
  }

  logInternal(args, console.info);
}
function error() {
  for (var _len2 = arguments.length, args = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
    args[_key2] = arguments[_key2];
  }

  logInternal(args, console.error);
}
function warn() {
  for (var _len3 = arguments.length, args = new Array(_len3), _key3 = 0; _key3 < _len3; _key3++) {
    args[_key3] = arguments[_key3];
  }

  logInternal(args, console.warn);
}

function logInternal(args, func) {
  if (  true && typeof console !== 'undefined') {
    func.apply(void 0, ['[rte-controller] '].concat((0,_babel_runtime_helpers_toConsumableArray__WEBPACK_IMPORTED_MODULE_0__["default"])(args)));
  }
}

/***/ }),

/***/ "./src/profiling.ts":
/*!**************************!*\
  !*** ./src/profiling.ts ***!
  \**************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __nested_webpack_require_38293__) => {

"use strict";
__nested_webpack_require_38293__.r(__webpack_exports__);


/***/ }),

/***/ "./src/rte.ts":
/*!********************!*\
  !*** ./src/rte.ts ***!
  \********************/
/***/ ((__unused_webpack_module, __webpack_exports__, __nested_webpack_require_38544__) => {

"use strict";
__nested_webpack_require_38544__.r(__webpack_exports__);
/* harmony export */ __nested_webpack_require_38544__.d(__webpack_exports__, {
/* harmony export */   "getExportedRte": () => (/* binding */ getExportedRte),
/* harmony export */   "isRteExtensionMsg": () => (/* binding */ isRteExtensionMsg),
/* harmony export */   "openBidirectionalChannelToRte": () => (/* binding */ openBidirectionalChannelToRte)
/* harmony export */ });
/* harmony import */ var _babel_runtime_regenerator__WEBPACK_IMPORTED_MODULE_0__ = __nested_webpack_require_38544__(/*! @babel/runtime/regenerator */ "./node_modules/@babel/runtime/regenerator/index.js");
/* harmony import */ var _babel_runtime_regenerator__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__nested_webpack_require_38544__.n(_babel_runtime_regenerator__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _logger__WEBPACK_IMPORTED_MODULE_1__ = __nested_webpack_require_38544__(/*! ./logger */ "./src/logger.ts");


var __awaiter =  false || function (thisArg, _arguments, P, generator) {
  function adopt(value) {
    return value instanceof P ? value : new P(function (resolve) {
      resolve(value);
    });
  }

  return new (P || (P = Promise))(function (resolve, reject) {
    function fulfilled(value) {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    }

    function rejected(value) {
      try {
        step(generator["throw"](value));
      } catch (e) {
        reject(e);
      }
    }

    function step(result) {
      result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected);
    }

    step((generator = generator.apply(thisArg, _arguments || [])).next());
  });
};


/**
 * Send a special command named 'open_bidirectional_channel' to the specified
 * extension of a RTE app, so that the RTE extension could 'remember' where the
 * command is coming from, and then send any future 'events' back to the UI
 * widgets in the future.
 */

function openBidirectionalChannelToRte(rteContext) {
  return __awaiter(this, void 0, void 0, /*#__PURE__*/_babel_runtime_regenerator__WEBPACK_IMPORTED_MODULE_0___default().mark(function _callee() {
    var request;
    return _babel_runtime_regenerator__WEBPACK_IMPORTED_MODULE_0___default().wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            // Construct a special 'open_bidirectional_channel' command, and send it to
            // the prebuilt graph of a RTE app.
            request = {
              command: 'open_bidirectional_channel'
            };
            _context.next = 3;
            return rteContext.sendRequestToRteExtension(request);

          case 3:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));
}

function isObject(obj) {
  return Object.prototype.toString.call(obj).slice(1, 7) === 'object';
}
/**
 * Check if the message is a RTE command.
 */


function isRteExtensionMsg(message) {
  if (!isObject(message)) {
    return false;
  } // All RTE commands should contain a 'command' field, so we use this fact to
  // determine if the 'message' is a RTE command or not.
  //
  // TODO(Wei): Need a more elegant way to determine if the message is a RTE
  // extension message or a RTE UI widget message.


  if (message.command !== undefined && message.command === 'status') {
    return true;
  }

  return false;
}
/**
 * Return the exported RTE object, only works if running in the same rendering
 * thread as RTE context.
 *
 * @returns rte | null
 */

function getExportedRte(extensionName, extensionGroupName) {
  var timeoutInSeconds = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 10;
  return __awaiter(this, void 0, void 0, /*#__PURE__*/_babel_runtime_regenerator__WEBPACK_IMPORTED_MODULE_0___default().mark(function _callee2() {
    var period;
    return _babel_runtime_regenerator__WEBPACK_IMPORTED_MODULE_0___default().wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            period = 100; // ms
            // We cannot call RteRuntime.getExportedRte directly, as 'RteRuntime' maybe
            // undefined. The 'RteRuntime' is assigned after the 'rte-runtime' module has
            // been loaded.

            return _context2.abrupt("return", new Promise(function (resolve, reject) {
              if (globalThis.RteRuntime) {
                var getExportedRteFunc = globalThis.RteRuntime.getExportedRte;
                resolve(getExportedRteFunc(extensionName, extensionGroupName, timeoutInSeconds));
                return;
              }

              var duration = 0; // ms

              var timer = setInterval(function () {
                duration += period;

                if (globalThis.RteRuntime) {
                  var _getExportedRteFunc = globalThis.RteRuntime.getExportedRte;
                  clearInterval(timer);
                  resolve(_getExportedRteFunc(extensionName, extensionGroupName, timeoutInSeconds));
                  return;
                }

                if (duration >= timeoutInSeconds * 1000) {
                  clearInterval(timer);
                  _logger__WEBPACK_IMPORTED_MODULE_1__.warn('The rte-runtime module has not loaded yet.');
                  reject(new Error('Error to fetch RteRuntime, make sure that the rte-runtime module \
has been loaded.'));
                }
              }, period);
            }));

          case 2:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2);
  }));
}

/***/ }),

/***/ "./src/websocket.ts":
/*!**************************!*\
  !*** ./src/websocket.ts ***!
  \**************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __nested_webpack_require_44404__) => {

"use strict";
__nested_webpack_require_44404__.r(__webpack_exports__);
/* harmony export */ __nested_webpack_require_44404__.d(__webpack_exports__, {
/* harmony export */   "checkWsConnection": () => (/* binding */ checkWsConnection),
/* harmony export */   "connectToRteAppThroughWebsocket": () => (/* binding */ connectToRteAppThroughWebsocket)
/* harmony export */ });
/* harmony import */ var _babel_runtime_regenerator__WEBPACK_IMPORTED_MODULE_0__ = __nested_webpack_require_44404__(/*! @babel/runtime/regenerator */ "./node_modules/@babel/runtime/regenerator/index.js");
/* harmony import */ var _babel_runtime_regenerator__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__nested_webpack_require_44404__.n(_babel_runtime_regenerator__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _logger__WEBPACK_IMPORTED_MODULE_1__ = __nested_webpack_require_44404__(/*! ./logger */ "./src/logger.ts");
/* harmony import */ var _rte__WEBPACK_IMPORTED_MODULE_2__ = __nested_webpack_require_44404__(/*! ./rte */ "./src/rte.ts");


var __awaiter =  false || function (thisArg, _arguments, P, generator) {
  function adopt(value) {
    return value instanceof P ? value : new P(function (resolve) {
      resolve(value);
    });
  }

  return new (P || (P = Promise))(function (resolve, reject) {
    function fulfilled(value) {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    }

    function rejected(value) {
      try {
        step(generator["throw"](value));
      } catch (e) {
        reject(e);
      }
    }

    function step(result) {
      result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected);
    }

    step((generator = generator.apply(thisArg, _arguments || [])).next());
  });
};


 // Replace the URI schema from http to ws.

function transHttpToWs(httpUri) {
  return httpUri.replace('http', 'ws');
}
/**
 * Create a websocket channel and connect to a RTE app.
 *
 * @param appUri The URI of the app.
 * @returns The constructed websocket channel.
 */


function connectToRteAppThroughWebsocket(rteContext) {
  return __awaiter(this, void 0, void 0, /*#__PURE__*/_babel_runtime_regenerator__WEBPACK_IMPORTED_MODULE_0___default().mark(function _callee() {
    return _babel_runtime_regenerator__WEBPACK_IMPORTED_MODULE_0___default().wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            return _context.abrupt("return", new Promise(function (resolve) {
              var websocketUri = transHttpToWs(rteContext.gatewayLoc.uri);
              var ws = new WebSocket(websocketUri);

              ws.onmessage = function (event) {
                var payload = event.data;
                var message = JSON.parse(payload);
                _logger__WEBPACK_IMPORTED_MODULE_1__.info("Received ".concat(JSON.stringify(message)));

                if ((0,_rte__WEBPACK_IMPORTED_MODULE_2__.isRteExtensionMsg)(message)) {
                  if (message.command === 'status') {
                    _logger__WEBPACK_IMPORTED_MODULE_1__.info('This is the response to open_bidirectional_channel.');
                    return;
                  }
                } else {
                  // Publish the received messages from RTE extensions to UI widgets.
                  rteContext.dispatchWidgetMessage(message);
                }
              };

              ws.onopen = function () {
                _logger__WEBPACK_IMPORTED_MODULE_1__.info('Websocket connected.');
                resolve(ws);
              };

              ws.onclose = function () {
                _logger__WEBPACK_IMPORTED_MODULE_1__.info('Websocket Closed');
              };

              return ws;
            }));

          case 1:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));
}
function checkWsConnection(uri, period, timeout) {
  return __awaiter(this, void 0, void 0, /*#__PURE__*/_babel_runtime_regenerator__WEBPACK_IMPORTED_MODULE_0___default().mark(function _callee2() {
    var waiting, wsUri;
    return _babel_runtime_regenerator__WEBPACK_IMPORTED_MODULE_0___default().wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            waiting = 0;
            wsUri = transHttpToWs(uri);
            return _context2.abrupt("return", new Promise(function (resolve, reject) {
              var timer = setInterval(function () {
                _logger__WEBPACK_IMPORTED_MODULE_1__.info('Do RTE App probe...');

                if (waiting >= timeout * 1000) {
                  clearInterval(timer);
                  reject(new Error("RTE App is not ready after ".concat(timeout, " seconds.")));
                  return;
                }

                var ws = new WebSocket(wsUri);

                ws.onopen = function () {
                  _logger__WEBPACK_IMPORTED_MODULE_1__.info('RTE App is ready.');
                  ws.close(1000
                  /* normal close */
                  );
                  clearInterval(timer);
                  resolve();
                };

                ws.onerror = function () {
                  ws.close(1000);
                  waiting += period;
                };
              }, period);
            }));

          case 3:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2);
  }));
}

/***/ }),

/***/ "./src/widget_props.ts":
/*!*****************************!*\
  !*** ./src/widget_props.ts ***!
  \*****************************/
/***/ ((__unused_webpack_module, __webpack_exports__, __nested_webpack_require_50064__) => {

"use strict";
__nested_webpack_require_50064__.r(__webpack_exports__);
/* harmony export */ __nested_webpack_require_50064__.d(__webpack_exports__, {
/* harmony export */   "getRteUiWidgetList": () => (/* binding */ getRteUiWidgetList),
/* harmony export */   "getRteUiWidgetResource": () => (/* binding */ getRteUiWidgetResource),
/* harmony export */   "getWidgetPropsFromExtension": () => (/* binding */ getWidgetPropsFromExtension),
/* harmony export */   "subscribeRteUiWidgetMsg": () => (/* binding */ subscribeRteUiWidgetMsg),
/* harmony export */   "unSubscribeRteUiWidgetMsg": () => (/* binding */ unSubscribeRteUiWidgetMsg)
/* harmony export */ });
/* harmony import */ var _babel_runtime_regenerator__WEBPACK_IMPORTED_MODULE_0__ = __nested_webpack_require_50064__(/*! @babel/runtime/regenerator */ "./node_modules/@babel/runtime/regenerator/index.js");
/* harmony import */ var _babel_runtime_regenerator__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__nested_webpack_require_50064__.n(_babel_runtime_regenerator__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _common__WEBPACK_IMPORTED_MODULE_1__ = __nested_webpack_require_50064__(/*! ./common */ "./src/common.ts");
/* harmony import */ var _logger__WEBPACK_IMPORTED_MODULE_2__ = __nested_webpack_require_50064__(/*! ./logger */ "./src/logger.ts");


var __awaiter =  false || function (thisArg, _arguments, P, generator) {
  function adopt(value) {
    return value instanceof P ? value : new P(function (resolve) {
      resolve(value);
    });
  }

  return new (P || (P = Promise))(function (resolve, reject) {
    function fulfilled(value) {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    }

    function rejected(value) {
      try {
        step(generator["throw"](value));
      } catch (e) {
        reject(e);
      }
    }

    function step(result) {
      result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected);
    }

    step((generator = generator.apply(thisArg, _arguments || [])).next());
  });
};




function getRteUiWidgetListInner(rteContext) {
  return __awaiter(this, void 0, void 0, /*#__PURE__*/_babel_runtime_regenerator__WEBPACK_IMPORTED_MODULE_0___default().mark(function _callee() {
    var request, data;
    return _babel_runtime_regenerator__WEBPACK_IMPORTED_MODULE_0___default().wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            request = {
              command: 'get_ui_widget_list'
            }; // Send a special 'get_ui_widget_list' to the RTE app.

            _context.next = 3;
            return rteContext.sendRequestToRteExtension(request, undefined, true);

          case 3:
            data = _context.sent;

            if (data) {
              _context.next = 6;
              break;
            }

            return _context.abrupt("return", {
              widgets: []
            });

          case 6:
            return _context.abrupt("return", data);

          case 7:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));
}

function getRteUiWidgetList(rteContext) {
  return __awaiter(this, void 0, void 0, /*#__PURE__*/_babel_runtime_regenerator__WEBPACK_IMPORTED_MODULE_0___default().mark(function _callee2() {
    var data, setReady, addRteUiWidgetMsgHandler, removeRteUiWidgetMsgHandler;
    return _babel_runtime_regenerator__WEBPACK_IMPORTED_MODULE_0___default().wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            _logger__WEBPACK_IMPORTED_MODULE_2__.info('Try to get ui widgets.');
            _context2.next = 3;
            return getRteUiWidgetListInner(rteContext);

          case 3:
            data = _context2.sent;
            _logger__WEBPACK_IMPORTED_MODULE_2__.info("Get UI widgets with layouts: ".concat(JSON.stringify(data)));

            setReady = function setReady(rteContext, rteUiWidgetInfo, error) {
              rteContext.onWidgetReady(rteUiWidgetInfo, error);
            };

            addRteUiWidgetMsgHandler = function addRteUiWidgetMsgHandler(rteUiWidgetInfo, handler) {
              rteUiWidgetInfo.rteUiWidgetMsgHandlers.push(handler);
            };

            removeRteUiWidgetMsgHandler = function removeRteUiWidgetMsgHandler(rteUiWidgetInfo, handler) {
              var index = rteUiWidgetInfo.rteUiWidgetMsgHandlers.indexOf(handler);

              if (index !== -1) {
                rteUiWidgetInfo.rteUiWidgetMsgHandlers.splice(index, 1);
              }
            };

            data.widgets.forEach(function (v) {
              v.uri = rteContext.gatewayLoc.uri;
              v.isReady = false;
              v.setReady = setReady;
              v.rteUiWidgetMsgHandlers = [];
              v.addRteUiWidgetMsgHandler = addRteUiWidgetMsgHandler;
              v.removeRteUiWidgetMsgHandler = removeRteUiWidgetMsgHandler;
              v.profilingEvents = [];
            });
            return _context2.abrupt("return", data);

          case 10:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2);
  }));
}
function getWidgetPropsFromExtension(rteContext, rteUiWidgetInfo) {
  return __awaiter(this, void 0, void 0, /*#__PURE__*/_babel_runtime_regenerator__WEBPACK_IMPORTED_MODULE_0___default().mark(function _callee3() {
    var result, getRteCb, request, props;
    return _babel_runtime_regenerator__WEBPACK_IMPORTED_MODULE_0___default().wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            _context3.prev = 0;
            // TODO(Liu): Refine to a wrapper.
            rteContext.submitProfilingEvent(rteUiWidgetInfo.extension, rteUiWidgetInfo.extension_group, 'get-widget-props');
            result = {};

            getRteCb = function getRteCb(rte) {
              _logger__WEBPACK_IMPORTED_MODULE_2__.info("The ui widget gets the extension(".concat(rteUiWidgetInfo.extension, ")'s related RTE object."));
              result.rte = rte;
            };

            request = new globalThis.RteRuntime.Cmd({
              command: 'get_widget_props',
              dest: [rteUiWidgetInfo]
            }); // The ui widget needs the extension's related 'RTE' object to communicate
            // with the extension. But the ui widget cannot get it through
            // 'getExportedRte(extension_group_name, extension_name)', as it does not
            // know the name of the extension, and the name of the extension group of
            // the extension. So rte-controller will get the related 'RTE' object
            // through 'get_widget_props' command here, and transport it to the ui
            // widget with props in rendering.
            // TODO(Liu): the RTE runtime does not support returning a JS object now, so
            // we hack here. Remove the callback if the runtime supports.

            request.setProperty('additional', new globalThis.RteRuntime.Value({
              cb: getRteCb
            }));
            _context3.next = 8;
            return rteContext.sendCmdToRteExtension(request);

          case 8:
            props = _context3.sent;

            if (props) {
              _context3.next = 11;
              break;
            }

            return _context3.abrupt("return", result);

          case 11:
            Object.assign(result, props);
            return _context3.abrupt("return", result);

          case 13:
            _context3.prev = 13;
            rteContext.submitProfilingEvent(rteUiWidgetInfo.extension, rteUiWidgetInfo.extension_group, 'get-widget-props');
            return _context3.finish(13);

          case 16:
          case "end":
            return _context3.stop();
        }
      }
    }, _callee3, null, [[0,, 13, 16]]);
  }));
} // @{
// The interfaces for UI developers.

/**
 * Subscribe UI widget messages from RTE.
 *
 * @param handler The message handler for the received messages.
 */

function subscribeRteUiWidgetMsg(rteUiWidgetInfo, handler) {
  rteUiWidgetInfo.addRteUiWidgetMsgHandler(rteUiWidgetInfo, handler);
}
/**
 * Un-subscribe messages from RTE.
 */

function unSubscribeRteUiWidgetMsg(rteUiWidgetInfo, handler) {
  rteUiWidgetInfo.removeRteUiWidgetMsgHandler(rteUiWidgetInfo, handler);
}
/**
 * Get more resources from RTE world relevant to the specified RTE UI widget.
 */

function getRteUiWidgetResource(uiWidgetInfo, relativePath, isLocalDevEnv) {
  var extension_group = uiWidgetInfo.extension_group,
      extension = uiWidgetInfo.extension,
      graph_id = uiWidgetInfo.graph_id,
      uri = uiWidgetInfo.uri;
  var baseUri = uiWidgetInfo.bundleBasePath ? uiWidgetInfo.bundleBasePath : "".concat(uri, "/").concat(graph_id, "/").concat(extension_group, "/").concat(extension, "/");
  _logger__WEBPACK_IMPORTED_MODULE_2__.info("getRteUiWidgetResource, bundleBasePath: ".concat(uiWidgetInfo.bundleBasePath, ",\n    base: ").concat(baseUri));
  return (0,_common__WEBPACK_IMPORTED_MODULE_1__.rteGetAbsoluteUri)(baseUri, relativePath, isLocalDevEnv);
} // @}

/***/ }),

/***/ "./node_modules/@babel/runtime/helpers/regeneratorRuntime.js":
/*!*******************************************************************!*\
  !*** ./node_modules/@babel/runtime/helpers/regeneratorRuntime.js ***!
  \*******************************************************************/
/***/ ((module, __unused_webpack_exports, __nested_webpack_require_59573__) => {

var _typeof = (__nested_webpack_require_59573__(/*! ./typeof.js */ "./node_modules/@babel/runtime/helpers/typeof.js")["default"]);

function _regeneratorRuntime() {
  "use strict";
  /*! regenerator-runtime -- Copyright (c) 2014-present, Facebook, Inc. -- license (MIT): https://github.com/facebook/regenerator/blob/main/LICENSE */

  module.exports = _regeneratorRuntime = function _regeneratorRuntime() {
    return exports;
  }, module.exports.__esModule = true, module.exports["default"] = module.exports;
  var exports = {},
      Op = Object.prototype,
      hasOwn = Op.hasOwnProperty,
      $Symbol = "function" == typeof Symbol ? Symbol : {},
      iteratorSymbol = $Symbol.iterator || "@@iterator",
      asyncIteratorSymbol = $Symbol.asyncIterator || "@@asyncIterator",
      toStringTagSymbol = $Symbol.toStringTag || "@@toStringTag";

  function define(obj, key, value) {
    return Object.defineProperty(obj, key, {
      value: value,
      enumerable: !0,
      configurable: !0,
      writable: !0
    }), obj[key];
  }

  try {
    define({}, "");
  } catch (err) {
    define = function define(obj, key, value) {
      return obj[key] = value;
    };
  }

  function wrap(innerFn, outerFn, self, tryLocsList) {
    var protoGenerator = outerFn && outerFn.prototype instanceof Generator ? outerFn : Generator,
        generator = Object.create(protoGenerator.prototype),
        context = new Context(tryLocsList || []);
    return generator._invoke = function (innerFn, self, context) {
      var state = "suspendedStart";
      return function (method, arg) {
        if ("executing" === state) throw new Error("Generator is already running");

        if ("completed" === state) {
          if ("throw" === method) throw arg;
          return doneResult();
        }

        for (context.method = method, context.arg = arg;;) {
          var delegate = context.delegate;

          if (delegate) {
            var delegateResult = maybeInvokeDelegate(delegate, context);

            if (delegateResult) {
              if (delegateResult === ContinueSentinel) continue;
              return delegateResult;
            }
          }

          if ("next" === context.method) context.sent = context._sent = context.arg;else if ("throw" === context.method) {
            if ("suspendedStart" === state) throw state = "completed", context.arg;
            context.dispatchException(context.arg);
          } else "return" === context.method && context.abrupt("return", context.arg);
          state = "executing";
          var record = tryCatch(innerFn, self, context);

          if ("normal" === record.type) {
            if (state = context.done ? "completed" : "suspendedYield", record.arg === ContinueSentinel) continue;
            return {
              value: record.arg,
              done: context.done
            };
          }

          "throw" === record.type && (state = "completed", context.method = "throw", context.arg = record.arg);
        }
      };
    }(innerFn, self, context), generator;
  }

  function tryCatch(fn, obj, arg) {
    try {
      return {
        type: "normal",
        arg: fn.call(obj, arg)
      };
    } catch (err) {
      return {
        type: "throw",
        arg: err
      };
    }
  }

  exports.wrap = wrap;
  var ContinueSentinel = {};

  function Generator() {}

  function GeneratorFunction() {}

  function GeneratorFunctionPrototype() {}

  var IteratorPrototype = {};
  define(IteratorPrototype, iteratorSymbol, function () {
    return this;
  });
  var getProto = Object.getPrototypeOf,
      NativeIteratorPrototype = getProto && getProto(getProto(values([])));
  NativeIteratorPrototype && NativeIteratorPrototype !== Op && hasOwn.call(NativeIteratorPrototype, iteratorSymbol) && (IteratorPrototype = NativeIteratorPrototype);
  var Gp = GeneratorFunctionPrototype.prototype = Generator.prototype = Object.create(IteratorPrototype);

  function defineIteratorMethods(prototype) {
    ["next", "throw", "return"].forEach(function (method) {
      define(prototype, method, function (arg) {
        return this._invoke(method, arg);
      });
    });
  }

  function AsyncIterator(generator, PromiseImpl) {
    function invoke(method, arg, resolve, reject) {
      var record = tryCatch(generator[method], generator, arg);

      if ("throw" !== record.type) {
        var result = record.arg,
            value = result.value;
        return value && "object" == _typeof(value) && hasOwn.call(value, "__await") ? PromiseImpl.resolve(value.__await).then(function (value) {
          invoke("next", value, resolve, reject);
        }, function (err) {
          invoke("throw", err, resolve, reject);
        }) : PromiseImpl.resolve(value).then(function (unwrapped) {
          result.value = unwrapped, resolve(result);
        }, function (error) {
          return invoke("throw", error, resolve, reject);
        });
      }

      reject(record.arg);
    }

    var previousPromise;

    this._invoke = function (method, arg) {
      function callInvokeWithMethodAndArg() {
        return new PromiseImpl(function (resolve, reject) {
          invoke(method, arg, resolve, reject);
        });
      }

      return previousPromise = previousPromise ? previousPromise.then(callInvokeWithMethodAndArg, callInvokeWithMethodAndArg) : callInvokeWithMethodAndArg();
    };
  }

  function maybeInvokeDelegate(delegate, context) {
    var method = delegate.iterator[context.method];

    if (undefined === method) {
      if (context.delegate = null, "throw" === context.method) {
        if (delegate.iterator["return"] && (context.method = "return", context.arg = undefined, maybeInvokeDelegate(delegate, context), "throw" === context.method)) return ContinueSentinel;
        context.method = "throw", context.arg = new TypeError("The iterator does not provide a 'throw' method");
      }

      return ContinueSentinel;
    }

    var record = tryCatch(method, delegate.iterator, context.arg);
    if ("throw" === record.type) return context.method = "throw", context.arg = record.arg, context.delegate = null, ContinueSentinel;
    var info = record.arg;
    return info ? info.done ? (context[delegate.resultName] = info.value, context.next = delegate.nextLoc, "return" !== context.method && (context.method = "next", context.arg = undefined), context.delegate = null, ContinueSentinel) : info : (context.method = "throw", context.arg = new TypeError("iterator result is not an object"), context.delegate = null, ContinueSentinel);
  }

  function pushTryEntry(locs) {
    var entry = {
      tryLoc: locs[0]
    };
    1 in locs && (entry.catchLoc = locs[1]), 2 in locs && (entry.finallyLoc = locs[2], entry.afterLoc = locs[3]), this.tryEntries.push(entry);
  }

  function resetTryEntry(entry) {
    var record = entry.completion || {};
    record.type = "normal", delete record.arg, entry.completion = record;
  }

  function Context(tryLocsList) {
    this.tryEntries = [{
      tryLoc: "root"
    }], tryLocsList.forEach(pushTryEntry, this), this.reset(!0);
  }

  function values(iterable) {
    if (iterable) {
      var iteratorMethod = iterable[iteratorSymbol];
      if (iteratorMethod) return iteratorMethod.call(iterable);
      if ("function" == typeof iterable.next) return iterable;

      if (!isNaN(iterable.length)) {
        var i = -1,
            next = function next() {
          for (; ++i < iterable.length;) {
            if (hasOwn.call(iterable, i)) return next.value = iterable[i], next.done = !1, next;
          }

          return next.value = undefined, next.done = !0, next;
        };

        return next.next = next;
      }
    }

    return {
      next: doneResult
    };
  }

  function doneResult() {
    return {
      value: undefined,
      done: !0
    };
  }

  return GeneratorFunction.prototype = GeneratorFunctionPrototype, define(Gp, "constructor", GeneratorFunctionPrototype), define(GeneratorFunctionPrototype, "constructor", GeneratorFunction), GeneratorFunction.displayName = define(GeneratorFunctionPrototype, toStringTagSymbol, "GeneratorFunction"), exports.isGeneratorFunction = function (genFun) {
    var ctor = "function" == typeof genFun && genFun.constructor;
    return !!ctor && (ctor === GeneratorFunction || "GeneratorFunction" === (ctor.displayName || ctor.name));
  }, exports.mark = function (genFun) {
    return Object.setPrototypeOf ? Object.setPrototypeOf(genFun, GeneratorFunctionPrototype) : (genFun.__proto__ = GeneratorFunctionPrototype, define(genFun, toStringTagSymbol, "GeneratorFunction")), genFun.prototype = Object.create(Gp), genFun;
  }, exports.awrap = function (arg) {
    return {
      __await: arg
    };
  }, defineIteratorMethods(AsyncIterator.prototype), define(AsyncIterator.prototype, asyncIteratorSymbol, function () {
    return this;
  }), exports.AsyncIterator = AsyncIterator, exports.async = function (innerFn, outerFn, self, tryLocsList, PromiseImpl) {
    void 0 === PromiseImpl && (PromiseImpl = Promise);
    var iter = new AsyncIterator(wrap(innerFn, outerFn, self, tryLocsList), PromiseImpl);
    return exports.isGeneratorFunction(outerFn) ? iter : iter.next().then(function (result) {
      return result.done ? result.value : iter.next();
    });
  }, defineIteratorMethods(Gp), define(Gp, toStringTagSymbol, "Generator"), define(Gp, iteratorSymbol, function () {
    return this;
  }), define(Gp, "toString", function () {
    return "[object Generator]";
  }), exports.keys = function (object) {
    var keys = [];

    for (var key in object) {
      keys.push(key);
    }

    return keys.reverse(), function next() {
      for (; keys.length;) {
        var key = keys.pop();
        if (key in object) return next.value = key, next.done = !1, next;
      }

      return next.done = !0, next;
    };
  }, exports.values = values, Context.prototype = {
    constructor: Context,
    reset: function reset(skipTempReset) {
      if (this.prev = 0, this.next = 0, this.sent = this._sent = undefined, this.done = !1, this.delegate = null, this.method = "next", this.arg = undefined, this.tryEntries.forEach(resetTryEntry), !skipTempReset) for (var name in this) {
        "t" === name.charAt(0) && hasOwn.call(this, name) && !isNaN(+name.slice(1)) && (this[name] = undefined);
      }
    },
    stop: function stop() {
      this.done = !0;
      var rootRecord = this.tryEntries[0].completion;
      if ("throw" === rootRecord.type) throw rootRecord.arg;
      return this.rval;
    },
    dispatchException: function dispatchException(exception) {
      if (this.done) throw exception;
      var context = this;

      function handle(loc, caught) {
        return record.type = "throw", record.arg = exception, context.next = loc, caught && (context.method = "next", context.arg = undefined), !!caught;
      }

      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i],
            record = entry.completion;
        if ("root" === entry.tryLoc) return handle("end");

        if (entry.tryLoc <= this.prev) {
          var hasCatch = hasOwn.call(entry, "catchLoc"),
              hasFinally = hasOwn.call(entry, "finallyLoc");

          if (hasCatch && hasFinally) {
            if (this.prev < entry.catchLoc) return handle(entry.catchLoc, !0);
            if (this.prev < entry.finallyLoc) return handle(entry.finallyLoc);
          } else if (hasCatch) {
            if (this.prev < entry.catchLoc) return handle(entry.catchLoc, !0);
          } else {
            if (!hasFinally) throw new Error("try statement without catch or finally");
            if (this.prev < entry.finallyLoc) return handle(entry.finallyLoc);
          }
        }
      }
    },
    abrupt: function abrupt(type, arg) {
      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];

        if (entry.tryLoc <= this.prev && hasOwn.call(entry, "finallyLoc") && this.prev < entry.finallyLoc) {
          var finallyEntry = entry;
          break;
        }
      }

      finallyEntry && ("break" === type || "continue" === type) && finallyEntry.tryLoc <= arg && arg <= finallyEntry.finallyLoc && (finallyEntry = null);
      var record = finallyEntry ? finallyEntry.completion : {};
      return record.type = type, record.arg = arg, finallyEntry ? (this.method = "next", this.next = finallyEntry.finallyLoc, ContinueSentinel) : this.complete(record);
    },
    complete: function complete(record, afterLoc) {
      if ("throw" === record.type) throw record.arg;
      return "break" === record.type || "continue" === record.type ? this.next = record.arg : "return" === record.type ? (this.rval = this.arg = record.arg, this.method = "return", this.next = "end") : "normal" === record.type && afterLoc && (this.next = afterLoc), ContinueSentinel;
    },
    finish: function finish(finallyLoc) {
      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];
        if (entry.finallyLoc === finallyLoc) return this.complete(entry.completion, entry.afterLoc), resetTryEntry(entry), ContinueSentinel;
      }
    },
    "catch": function _catch(tryLoc) {
      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];

        if (entry.tryLoc === tryLoc) {
          var record = entry.completion;

          if ("throw" === record.type) {
            var thrown = record.arg;
            resetTryEntry(entry);
          }

          return thrown;
        }
      }

      throw new Error("illegal catch attempt");
    },
    delegateYield: function delegateYield(iterable, resultName, nextLoc) {
      return this.delegate = {
        iterator: values(iterable),
        resultName: resultName,
        nextLoc: nextLoc
      }, "next" === this.method && (this.arg = undefined), ContinueSentinel;
    }
  }, exports;
}

module.exports = _regeneratorRuntime, module.exports.__esModule = true, module.exports["default"] = module.exports;

/***/ }),

/***/ "./node_modules/@babel/runtime/helpers/typeof.js":
/*!*******************************************************!*\
  !*** ./node_modules/@babel/runtime/helpers/typeof.js ***!
  \*******************************************************/
/***/ ((module) => {

function _typeof(obj) {
  "@babel/helpers - typeof";

  return (module.exports = _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) {
    return typeof obj;
  } : function (obj) {
    return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
  }, module.exports.__esModule = true, module.exports["default"] = module.exports), _typeof(obj);
}

module.exports = _typeof, module.exports.__esModule = true, module.exports["default"] = module.exports;

/***/ }),

/***/ "./node_modules/@babel/runtime/regenerator/index.js":
/*!**********************************************************!*\
  !*** ./node_modules/@babel/runtime/regenerator/index.js ***!
  \**********************************************************/
/***/ ((module, __unused_webpack_exports, __nested_webpack_require_74710__) => {

// TODO(Babel 8): Remove this file.

var runtime = __nested_webpack_require_74710__(/*! ../helpers/regeneratorRuntime */ "./node_modules/@babel/runtime/helpers/regeneratorRuntime.js")();
module.exports = runtime;

// Copied from https://github.com/facebook/regenerator/blob/main/packages/runtime/runtime.js#L736=
try {
  regeneratorRuntime = runtime;
} catch (accidentalStrictMode) {
  if (typeof globalThis === "object") {
    globalThis.regeneratorRuntime = runtime;
  } else {
    Function("r", "regeneratorRuntime = r")(runtime);
  }
}


/***/ }),

/***/ "./node_modules/@babel/runtime/helpers/esm/arrayLikeToArray.js":
/*!*********************************************************************!*\
  !*** ./node_modules/@babel/runtime/helpers/esm/arrayLikeToArray.js ***!
  \*********************************************************************/
/***/ ((__unused_webpack___webpack_module__, __webpack_exports__, __nested_webpack_require_75638__) => {

"use strict";
__nested_webpack_require_75638__.r(__webpack_exports__);
/* harmony export */ __nested_webpack_require_75638__.d(__webpack_exports__, {
/* harmony export */   "default": () => (/* binding */ _arrayLikeToArray)
/* harmony export */ });
function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length) len = arr.length;

  for (var i = 0, arr2 = new Array(len); i < len; i++) {
    arr2[i] = arr[i];
  }

  return arr2;
}

/***/ }),

/***/ "./node_modules/@babel/runtime/helpers/esm/arrayWithoutHoles.js":
/*!**********************************************************************!*\
  !*** ./node_modules/@babel/runtime/helpers/esm/arrayWithoutHoles.js ***!
  \**********************************************************************/
/***/ ((__unused_webpack___webpack_module__, __webpack_exports__, __nested_webpack_require_76463__) => {

"use strict";
__nested_webpack_require_76463__.r(__webpack_exports__);
/* harmony export */ __nested_webpack_require_76463__.d(__webpack_exports__, {
/* harmony export */   "default": () => (/* binding */ _arrayWithoutHoles)
/* harmony export */ });
/* harmony import */ var _arrayLikeToArray_js__WEBPACK_IMPORTED_MODULE_0__ = __nested_webpack_require_76463__(/*! ./arrayLikeToArray.js */ "./node_modules/@babel/runtime/helpers/esm/arrayLikeToArray.js");

function _arrayWithoutHoles(arr) {
  if (Array.isArray(arr)) return (0,_arrayLikeToArray_js__WEBPACK_IMPORTED_MODULE_0__["default"])(arr);
}

/***/ }),

/***/ "./node_modules/@babel/runtime/helpers/esm/classCallCheck.js":
/*!*******************************************************************!*\
  !*** ./node_modules/@babel/runtime/helpers/esm/classCallCheck.js ***!
  \*******************************************************************/
/***/ ((__unused_webpack___webpack_module__, __webpack_exports__, __nested_webpack_require_77413__) => {

"use strict";
__nested_webpack_require_77413__.r(__webpack_exports__);
/* harmony export */ __nested_webpack_require_77413__.d(__webpack_exports__, {
/* harmony export */   "default": () => (/* binding */ _classCallCheck)
/* harmony export */ });
function _classCallCheck(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
}

/***/ }),

/***/ "./node_modules/@babel/runtime/helpers/esm/createClass.js":
/*!****************************************************************!*\
  !*** ./node_modules/@babel/runtime/helpers/esm/createClass.js ***!
  \****************************************************************/
/***/ ((__unused_webpack___webpack_module__, __webpack_exports__, __nested_webpack_require_78176__) => {

"use strict";
__nested_webpack_require_78176__.r(__webpack_exports__);
/* harmony export */ __nested_webpack_require_78176__.d(__webpack_exports__, {
/* harmony export */   "default": () => (/* binding */ _createClass)
/* harmony export */ });
function _defineProperties(target, props) {
  for (var i = 0; i < props.length; i++) {
    var descriptor = props[i];
    descriptor.enumerable = descriptor.enumerable || false;
    descriptor.configurable = true;
    if ("value" in descriptor) descriptor.writable = true;
    Object.defineProperty(target, descriptor.key, descriptor);
  }
}

function _createClass(Constructor, protoProps, staticProps) {
  if (protoProps) _defineProperties(Constructor.prototype, protoProps);
  if (staticProps) _defineProperties(Constructor, staticProps);
  Object.defineProperty(Constructor, "prototype", {
    writable: false
  });
  return Constructor;
}

/***/ }),

/***/ "./node_modules/@babel/runtime/helpers/esm/iterableToArray.js":
/*!********************************************************************!*\
  !*** ./node_modules/@babel/runtime/helpers/esm/iterableToArray.js ***!
  \********************************************************************/
/***/ ((__unused_webpack___webpack_module__, __webpack_exports__, __nested_webpack_require_79433__) => {

"use strict";
__nested_webpack_require_79433__.r(__webpack_exports__);
/* harmony export */ __nested_webpack_require_79433__.d(__webpack_exports__, {
/* harmony export */   "default": () => (/* binding */ _iterableToArray)
/* harmony export */ });
function _iterableToArray(iter) {
  if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter);
}

/***/ }),

/***/ "./node_modules/@babel/runtime/helpers/esm/nonIterableSpread.js":
/*!**********************************************************************!*\
  !*** ./node_modules/@babel/runtime/helpers/esm/nonIterableSpread.js ***!
  \**********************************************************************/
/***/ ((__unused_webpack___webpack_module__, __webpack_exports__, __nested_webpack_require_80220__) => {

"use strict";
__nested_webpack_require_80220__.r(__webpack_exports__);
/* harmony export */ __nested_webpack_require_80220__.d(__webpack_exports__, {
/* harmony export */   "default": () => (/* binding */ _nonIterableSpread)
/* harmony export */ });
function _nonIterableSpread() {
  throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}

/***/ }),

/***/ "./node_modules/@babel/runtime/helpers/esm/toConsumableArray.js":
/*!**********************************************************************!*\
  !*** ./node_modules/@babel/runtime/helpers/esm/toConsumableArray.js ***!
  \**********************************************************************/
/***/ ((__unused_webpack___webpack_module__, __webpack_exports__, __nested_webpack_require_81041__) => {

"use strict";
__nested_webpack_require_81041__.r(__webpack_exports__);
/* harmony export */ __nested_webpack_require_81041__.d(__webpack_exports__, {
/* harmony export */   "default": () => (/* binding */ _toConsumableArray)
/* harmony export */ });
/* harmony import */ var _arrayWithoutHoles_js__WEBPACK_IMPORTED_MODULE_0__ = __nested_webpack_require_81041__(/*! ./arrayWithoutHoles.js */ "./node_modules/@babel/runtime/helpers/esm/arrayWithoutHoles.js");
/* harmony import */ var _iterableToArray_js__WEBPACK_IMPORTED_MODULE_1__ = __nested_webpack_require_81041__(/*! ./iterableToArray.js */ "./node_modules/@babel/runtime/helpers/esm/iterableToArray.js");
/* harmony import */ var _unsupportedIterableToArray_js__WEBPACK_IMPORTED_MODULE_2__ = __nested_webpack_require_81041__(/*! ./unsupportedIterableToArray.js */ "./node_modules/@babel/runtime/helpers/esm/unsupportedIterableToArray.js");
/* harmony import */ var _nonIterableSpread_js__WEBPACK_IMPORTED_MODULE_3__ = __nested_webpack_require_81041__(/*! ./nonIterableSpread.js */ "./node_modules/@babel/runtime/helpers/esm/nonIterableSpread.js");




function _toConsumableArray(arr) {
  return (0,_arrayWithoutHoles_js__WEBPACK_IMPORTED_MODULE_0__["default"])(arr) || (0,_iterableToArray_js__WEBPACK_IMPORTED_MODULE_1__["default"])(arr) || (0,_unsupportedIterableToArray_js__WEBPACK_IMPORTED_MODULE_2__["default"])(arr) || (0,_nonIterableSpread_js__WEBPACK_IMPORTED_MODULE_3__["default"])();
}

/***/ }),

/***/ "./node_modules/@babel/runtime/helpers/esm/unsupportedIterableToArray.js":
/*!*******************************************************************************!*\
  !*** ./node_modules/@babel/runtime/helpers/esm/unsupportedIterableToArray.js ***!
  \*******************************************************************************/
/***/ ((__unused_webpack___webpack_module__, __webpack_exports__, __nested_webpack_require_82854__) => {

"use strict";
__nested_webpack_require_82854__.r(__webpack_exports__);
/* harmony export */ __nested_webpack_require_82854__.d(__webpack_exports__, {
/* harmony export */   "default": () => (/* binding */ _unsupportedIterableToArray)
/* harmony export */ });
/* harmony import */ var _arrayLikeToArray_js__WEBPACK_IMPORTED_MODULE_0__ = __nested_webpack_require_82854__(/*! ./arrayLikeToArray.js */ "./node_modules/@babel/runtime/helpers/esm/arrayLikeToArray.js");

function _unsupportedIterableToArray(o, minLen) {
  if (!o) return;
  if (typeof o === "string") return (0,_arrayLikeToArray_js__WEBPACK_IMPORTED_MODULE_0__["default"])(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor) n = o.constructor.name;
  if (n === "Map" || n === "Set") return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return (0,_arrayLikeToArray_js__WEBPACK_IMPORTED_MODULE_0__["default"])(o, minLen);
}

/***/ })

/******/ 	});
/************************************************************************/
/******/ 	// The module cache
/******/ 	var __webpack_module_cache__ = {};
/******/ 	
/******/ 	// The require function
/******/ 	function __nested_webpack_require_84060__(moduleId) {
/******/ 		// Check if module is in cache
/******/ 		var cachedModule = __webpack_module_cache__[moduleId];
/******/ 		if (cachedModule !== undefined) {
/******/ 			return cachedModule.exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = __webpack_module_cache__[moduleId] = {
/******/ 			// no module.id needed
/******/ 			// no module.loaded needed
/******/ 			exports: {}
/******/ 		};
/******/ 	
/******/ 		// Execute the module function
/******/ 		__webpack_modules__[moduleId](module, module.exports, __nested_webpack_require_84060__);
/******/ 	
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/ 	
/************************************************************************/
/******/ 	/* webpack/runtime/compat get default export */
/******/ 	(() => {
/******/ 		// getDefaultExport function for compatibility with non-harmony modules
/******/ 		__nested_webpack_require_84060__.n = (module) => {
/******/ 			var getter = module && module.__esModule ?
/******/ 				() => (module['default']) :
/******/ 				() => (module);
/******/ 			__nested_webpack_require_84060__.d(getter, { a: getter });
/******/ 			return getter;
/******/ 		};
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/define property getters */
/******/ 	(() => {
/******/ 		// define getter functions for harmony exports
/******/ 		__nested_webpack_require_84060__.d = (exports, definition) => {
/******/ 			for(var key in definition) {
/******/ 				if(__nested_webpack_require_84060__.o(definition, key) && !__nested_webpack_require_84060__.o(exports, key)) {
/******/ 					Object.defineProperty(exports, key, { enumerable: true, get: definition[key] });
/******/ 				}
/******/ 			}
/******/ 		};
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/global */
/******/ 	(() => {
/******/ 		__nested_webpack_require_84060__.g = (function() {
/******/ 			if (typeof globalThis === 'object') return globalThis;
/******/ 			try {
/******/ 				return this || new Function('return this')();
/******/ 			} catch (e) {
/******/ 				if (typeof window === 'object') return window;
/******/ 			}
/******/ 		})();
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/hasOwnProperty shorthand */
/******/ 	(() => {
/******/ 		__nested_webpack_require_84060__.o = (obj, prop) => (Object.prototype.hasOwnProperty.call(obj, prop))
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/make namespace object */
/******/ 	(() => {
/******/ 		// define __esModule on exports
/******/ 		__nested_webpack_require_84060__.r = (exports) => {
/******/ 			if(typeof Symbol !== 'undefined' && Symbol.toStringTag) {
/******/ 				Object.defineProperty(exports, Symbol.toStringTag, { value: 'Module' });
/******/ 			}
/******/ 			Object.defineProperty(exports, '__esModule', { value: true });
/******/ 		};
/******/ 	})();
/******/ 	
/************************************************************************/
var __webpack_exports__ = {};
// This entry need to be wrapped in an IIFE because it need to be in strict mode.
(() => {
"use strict";
/*!**********************!*\
  !*** ./src/index.ts ***!
  \**********************/
__nested_webpack_require_84060__.r(__webpack_exports__);
/* harmony export */ __nested_webpack_require_84060__.d(__webpack_exports__, {
/* harmony export */   "RteContext": () => (/* reexport safe */ _context__WEBPACK_IMPORTED_MODULE_1__.RteContext),
/* harmony export */   "checkWsConnection": () => (/* reexport safe */ _websocket__WEBPACK_IMPORTED_MODULE_6__.checkWsConnection),
/* harmony export */   "connectToRteAppThroughWebsocket": () => (/* reexport safe */ _websocket__WEBPACK_IMPORTED_MODULE_6__.connectToRteAppThroughWebsocket),
/* harmony export */   "createDefaultRteContext": () => (/* reexport safe */ _context__WEBPACK_IMPORTED_MODULE_1__.createDefaultRteContext),
/* harmony export */   "getExportedRte": () => (/* reexport safe */ _rte__WEBPACK_IMPORTED_MODULE_5__.getExportedRte),
/* harmony export */   "getGlobalRteContext": () => (/* reexport safe */ _context__WEBPACK_IMPORTED_MODULE_1__.getGlobalRteContext),
/* harmony export */   "getRteUiWidgetList": () => (/* reexport safe */ _widget_props__WEBPACK_IMPORTED_MODULE_7__.getRteUiWidgetList),
/* harmony export */   "getRteUiWidgetResource": () => (/* reexport safe */ _widget_props__WEBPACK_IMPORTED_MODULE_7__.getRteUiWidgetResource),
/* harmony export */   "getWidgetPropsFromExtension": () => (/* reexport safe */ _widget_props__WEBPACK_IMPORTED_MODULE_7__.getWidgetPropsFromExtension),
/* harmony export */   "isRteExtensionMsg": () => (/* reexport safe */ _rte__WEBPACK_IMPORTED_MODULE_5__.isRteExtensionMsg),
/* harmony export */   "isStringEmpty": () => (/* reexport safe */ _common__WEBPACK_IMPORTED_MODULE_0__.isStringEmpty),
/* harmony export */   "log": () => (/* reexport module object */ _logger__WEBPACK_IMPORTED_MODULE_3__),
/* harmony export */   "openBidirectionalChannelToRte": () => (/* reexport safe */ _rte__WEBPACK_IMPORTED_MODULE_5__.openBidirectionalChannelToRte),
/* harmony export */   "registerRteContextAsGlobal": () => (/* reexport safe */ _context__WEBPACK_IMPORTED_MODULE_1__.registerRteContextAsGlobal),
/* harmony export */   "rteGetAbsoluteUri": () => (/* reexport safe */ _common__WEBPACK_IMPORTED_MODULE_0__.rteGetAbsoluteUri),
/* harmony export */   "rteHttpGet": () => (/* reexport safe */ _http__WEBPACK_IMPORTED_MODULE_2__.rteHttpGet),
/* harmony export */   "rteHttpPost": () => (/* reexport safe */ _http__WEBPACK_IMPORTED_MODULE_2__.rteHttpPost),
/* harmony export */   "rteHttpPut": () => (/* reexport safe */ _http__WEBPACK_IMPORTED_MODULE_2__.rteHttpPut),
/* harmony export */   "subscribeRteUiWidgetMsg": () => (/* reexport safe */ _widget_props__WEBPACK_IMPORTED_MODULE_7__.subscribeRteUiWidgetMsg),
/* harmony export */   "unSubscribeRteUiWidgetMsg": () => (/* reexport safe */ _widget_props__WEBPACK_IMPORTED_MODULE_7__.unSubscribeRteUiWidgetMsg)
/* harmony export */ });
/* harmony import */ var _common__WEBPACK_IMPORTED_MODULE_0__ = __nested_webpack_require_84060__(/*! ./common */ "./src/common.ts");
/* harmony import */ var _context__WEBPACK_IMPORTED_MODULE_1__ = __nested_webpack_require_84060__(/*! ./context */ "./src/context.ts");
/* harmony import */ var _http__WEBPACK_IMPORTED_MODULE_2__ = __nested_webpack_require_84060__(/*! ./http */ "./src/http.ts");
/* harmony import */ var _logger__WEBPACK_IMPORTED_MODULE_3__ = __nested_webpack_require_84060__(/*! ./logger */ "./src/logger.ts");
/* harmony import */ var _profiling__WEBPACK_IMPORTED_MODULE_4__ = __nested_webpack_require_84060__(/*! ./profiling */ "./src/profiling.ts");
/* harmony import */ var _rte__WEBPACK_IMPORTED_MODULE_5__ = __nested_webpack_require_84060__(/*! ./rte */ "./src/rte.ts");
/* harmony import */ var _websocket__WEBPACK_IMPORTED_MODULE_6__ = __nested_webpack_require_84060__(/*! ./websocket */ "./src/websocket.ts");
/* harmony import */ var _widget_props__WEBPACK_IMPORTED_MODULE_7__ = __nested_webpack_require_84060__(/*! ./widget_props */ "./src/widget_props.ts");
/**
 *
 * Agora Real Time Engagement
 * Created by summer.xia in 2022-01-20 21:31:27.
 * Copyright (c) 2015 Agora IO. All rights reserved.
 *
 */









})();

/******/ 	return __webpack_exports__;
/******/ })()
;
});
//# sourceMappingURL=index.js.map

/***/ }),

/***/ "./src/components/bundle.ts":
/*!**********************************!*\
  !*** ./src/components/bundle.ts ***!
  \**********************************/
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

var _interopRequireDefault=__webpack_require__(/*! @babel/runtime/helpers/interopRequireDefault */ "./node_modules/@babel/runtime/helpers/interopRequireDefault.js");Object.defineProperty(exports, "__esModule", ({value:true}));exports.getCjsModules=getCjsModules;exports.getModuleContent=getModuleContent;var _defineProperty2=_interopRequireDefault(__webpack_require__(/*! @babel/runtime/helpers/defineProperty */ "./node_modules/@babel/runtime/helpers/defineProperty.js"));var _slicedToArray2=_interopRequireDefault(__webpack_require__(/*! @babel/runtime/helpers/slicedToArray */ "./node_modules/@babel/runtime/helpers/slicedToArray.js"));var _toConsumableArray2=_interopRequireDefault(__webpack_require__(/*! @babel/runtime/helpers/toConsumableArray */ "./node_modules/@babel/runtime/helpers/toConsumableArray.js"));function getModuleContent(code_text,moduleName,modulesDependsOn){var modulesDependsOn_=Object.create(modulesDependsOn);function require(name){if(!(name in modulesDependsOn_)&&moduleName===name){var module={exports:{}};modulesDependsOn_[name]=function(){return module;};var wrapper=Function('require, exports, module, global',code_text);wrapper(require,module.exports,module,__webpack_require__.g);}else if(!(name in modulesDependsOn_)){throw new Error("Module '"+name+"' not found");}return modulesDependsOn_[name]().exports;}return require(moduleName);}var fromPairs=function fromPairs(cjsModuleGenerator){return Object.assign.apply(Object,[{}].concat((0,_toConsumableArray2.default)(cjsModuleGenerator.map(function(_ref){var _ref2=(0,_slicedToArray2.default)(_ref,2),k=_ref2[0],v=_ref2[1];return(0,_defineProperty2.default)({},k,v);}))));};function getCjsModules(modulesContentGenerator){return fromPairs(Object.keys(modulesContentGenerator).map(function(k){return[k,function(){return{exports:modulesContentGenerator[k]()};}];}));}

/***/ }),

/***/ "./src/components/modules_depend_on.ts":
/*!*********************************************!*\
  !*** ./src/components/modules_depend_on.ts ***!
  \*********************************************/
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

Object.defineProperty(exports, "__esModule", ({value:true}));exports.appendDefaultDepends=appendDefaultDepends;exports.defaultModulesDependsOn=void 0;var React=_interopRequireWildcard(__webpack_require__(/*! react */ "react"));var ReactNative=_interopRequireWildcard(__webpack_require__(/*! react-native */ "react-native"));var _bundle=__webpack_require__(/*! ./bundle */ "./src/components/bundle.ts");function _getRequireWildcardCache(nodeInterop){if(typeof WeakMap!=="function")return null;var cacheBabelInterop=new WeakMap();var cacheNodeInterop=new WeakMap();return(_getRequireWildcardCache=function _getRequireWildcardCache(nodeInterop){return nodeInterop?cacheNodeInterop:cacheBabelInterop;})(nodeInterop);}function _interopRequireWildcard(obj,nodeInterop){if(!nodeInterop&&obj&&obj.__esModule){return obj;}if(obj===null||typeof obj!=="object"&&typeof obj!=="function"){return{default:obj};}var cache=_getRequireWildcardCache(nodeInterop);if(cache&&cache.has(obj)){return cache.get(obj);}var newObj={};var hasPropertyDescriptor=Object.defineProperty&&Object.getOwnPropertyDescriptor;for(var key in obj){if(key!=="default"&&Object.prototype.hasOwnProperty.call(obj,key)){var desc=hasPropertyDescriptor?Object.getOwnPropertyDescriptor(obj,key):null;if(desc&&(desc.get||desc.set)){Object.defineProperty(newObj,key,desc);}else{newObj[key]=obj[key];}}}newObj.default=obj;if(cache){cache.set(obj,newObj);}return newObj;}var defaultModuleGenerators={react:function react(){return React;},'react-native':function reactNative(){return ReactNative;}};var defaultModulesDependsOn=(0,_bundle.getCjsModules)(defaultModuleGenerators);exports.defaultModulesDependsOn=defaultModulesDependsOn;function appendDefaultDepends(depends){return(0,_bundle.getCjsModules)(Object.assign(defaultModuleGenerators,depends));}

/***/ }),

/***/ "./src/components/remote_component.tsx":
/*!*********************************************!*\
  !*** ./src/components/remote_component.tsx ***!
  \*********************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

var _interopRequireDefault=__webpack_require__(/*! @babel/runtime/helpers/interopRequireDefault */ "./node_modules/@babel/runtime/helpers/interopRequireDefault.js");Object.defineProperty(exports, "__esModule", ({value:true}));exports.RemoteComponent=void 0;var _classCallCheck2=_interopRequireDefault(__webpack_require__(/*! @babel/runtime/helpers/classCallCheck */ "./node_modules/@babel/runtime/helpers/classCallCheck.js"));var _createClass2=_interopRequireDefault(__webpack_require__(/*! @babel/runtime/helpers/createClass */ "./node_modules/@babel/runtime/helpers/createClass.js"));var _inherits2=_interopRequireDefault(__webpack_require__(/*! @babel/runtime/helpers/inherits */ "./node_modules/@babel/runtime/helpers/inherits.js"));var _possibleConstructorReturn2=_interopRequireDefault(__webpack_require__(/*! @babel/runtime/helpers/possibleConstructorReturn */ "./node_modules/@babel/runtime/helpers/possibleConstructorReturn.js"));var _getPrototypeOf2=_interopRequireDefault(__webpack_require__(/*! @babel/runtime/helpers/getPrototypeOf */ "./node_modules/@babel/runtime/helpers/getPrototypeOf.js"));var _rteControllerBase=__webpack_require__(/*! @agora-rte/rte-controller-base */ "./node_modules/@agora-rte/rte-controller-base/lib/index.js");var _react=_interopRequireDefault(__webpack_require__(/*! react */ "react"));var _reactNative=__webpack_require__(/*! react-native */ "react-native");var _bundle=__webpack_require__(/*! ./bundle */ "./src/components/bundle.ts");var _modules_depend_on=__webpack_require__(/*! ./modules_depend_on */ "./src/components/modules_depend_on.ts");function _createSuper(Derived){var hasNativeReflectConstruct=_isNativeReflectConstruct();return function _createSuperInternal(){var Super=(0,_getPrototypeOf2.default)(Derived),result;if(hasNativeReflectConstruct){var NewTarget=(0,_getPrototypeOf2.default)(this).constructor;result=Reflect.construct(Super,arguments,NewTarget);}else{result=Super.apply(this,arguments);}return(0,_possibleConstructorReturn2.default)(this,result);};}function _isNativeReflectConstruct(){if(typeof Reflect==="undefined"||!Reflect.construct)return false;if(Reflect.construct.sham)return false;if(typeof Proxy==="function")return true;try{Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],function(){}));return true;}catch(e){return false;}}var __awaiter=this&&this.__awaiter||function(thisArg,_arguments,P,generator){function adopt(value){return value instanceof P?value:new P(function(resolve){resolve(value);});}return new(P||(P=Promise))(function(resolve,reject){function fulfilled(value){try{step(generator.next(value));}catch(e){reject(e);}}function rejected(value){try{step(generator["throw"](value));}catch(e){reject(e);}}function step(result){result.done?resolve(result.value):adopt(result.value).then(fulfilled,rejected);}step((generator=generator.apply(thisArg,_arguments||[])).next());});};function fetchComponent(content,depends){return __awaiter(this,void 0,void 0,function*(){try{var moduleName='default';var match=/exports\[["'](\S*?)['"]\]/.exec(content);if(match){moduleName=match[1];}var module={default:(0,_bundle.getModuleContent)(content,moduleName,depends?(0,_modules_depend_on.appendDefaultDepends)(depends):_modules_depend_on.defaultModulesDependsOn)};return module;}catch(error){_rteControllerBase.log.error(error);return{default:function _default(){return _react.default.createElement(_reactNative.Text,null,"Failed to Render",' ',error.toString());}};}});}function getBundleInfo(widgetInfo,rteContext){return __awaiter(this,void 0,void 0,function*(){try{rteContext.submitProfilingEvent(widgetInfo.extension,widgetInfo.extension_group,'get-widget-bundle');var indexResource=widgetInfo.indexResource,uri=widgetInfo.uri,graph_id=widgetInfo.graph_id,extension_group=widgetInfo.extension_group,extension=widgetInfo.extension;var isRemoteBundle=rteContext.gatewayLoc.uri.startsWith('http://');var bundleInfo={basePath:'',path:'',content:''};if(isRemoteBundle){var baseUri=uri+"/"+graph_id+"/"+extension_group+"/"+extension;bundleInfo.basePath=baseUri;bundleInfo.path=(0,_rteControllerBase.rteGetAbsoluteUri)(baseUri,indexResource);bundleInfo.content=yield fetch(bundleInfo.path,{mode:'cors',headers:{'Access-Control-Allow-Origin':'*'}}).then(function(resp){if(!resp.ok){throw new Error("Failed to fetch "+bundleInfo.path+": "+JSON.stringify(resp));}return resp.text();});}else{var _bundleInfo=yield rteContext.sendRequestToRteExtension({command:'read_widget_content',indexResource:indexResource},widgetInfo);if(_bundleInfo){return _bundleInfo;}throw new Error("Failed to find bundle info for resource "+indexResource);}_rteControllerBase.log.info("The bundle info of widget["+widgetInfo.extension+"]: "+JSON.stringify(bundleInfo));return bundleInfo;}finally{rteContext.submitProfilingEvent(widgetInfo.extension,widgetInfo.extension_group,'get-widget-bundle');}});}var RemoteComponent=function(_React$PureComponent){(0,_inherits2.default)(RemoteComponent,_React$PureComponent);var _super=_createSuper(RemoteComponent);function RemoteComponent(){(0,_classCallCheck2.default)(this,RemoteComponent);return _super.apply(this,arguments);}(0,_createClass2.default)(RemoteComponent,[{key:"componentDidUpdate",value:function componentDidUpdate(){_rteControllerBase.log.info("The ui widget["+this.props.rteUiWidgetInfo.extension+"] has updated.");}},{key:"render",value:function render(){var _this=this;var Comp=_react.default.lazy(function(){return __awaiter(_this,void 0,void 0,function*(){var _a;var bundleInfo=yield getBundleInfo(this.props.rteUiWidgetInfo,this.props.rteContext);this.submitProfiling('mount-widget');return fetchComponent(bundleInfo.content,(_a=this.props.options)===null||_a===void 0?void 0:_a.modulesDependedOn);});});_rteControllerBase.log.info("The ui widget("+this.props.rteUiWidgetInfo.extension+")'s props: "+JSON.stringify(this.props.rteUiWidgetInfo.propsFromExtension));return _react.default.createElement(_react.default.Suspense,{fallback:_react.default.createElement(_reactNative.View,null)},_react.default.createElement(Comp,Object.assign({},this.props,this.props.rteUiWidgetInfo.propsFromExtension)));}},{key:"submitProfiling",value:function submitProfiling(phase){return __awaiter(this,void 0,void 0,function*(){this.props.rteContext.submitProfilingEvent(this.props.rteUiWidgetInfo.extension,this.props.rteUiWidgetInfo.extension_group,phase);});}}]);return RemoteComponent;}(_react.default.PureComponent);exports.RemoteComponent=RemoteComponent;

/***/ }),

/***/ "./src/extension_container.tsx":
/*!*************************************!*\
  !*** ./src/extension_container.tsx ***!
  \*************************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {

var _interopRequireDefault=__webpack_require__(/*! @babel/runtime/helpers/interopRequireDefault */ "./node_modules/@babel/runtime/helpers/interopRequireDefault.js");Object.defineProperty(exports, "__esModule", ({value:true}));exports.ExtensionContainer=void 0;var _classCallCheck2=_interopRequireDefault(__webpack_require__(/*! @babel/runtime/helpers/classCallCheck */ "./node_modules/@babel/runtime/helpers/classCallCheck.js"));var _createClass2=_interopRequireDefault(__webpack_require__(/*! @babel/runtime/helpers/createClass */ "./node_modules/@babel/runtime/helpers/createClass.js"));var _inherits2=_interopRequireDefault(__webpack_require__(/*! @babel/runtime/helpers/inherits */ "./node_modules/@babel/runtime/helpers/inherits.js"));var _possibleConstructorReturn2=_interopRequireDefault(__webpack_require__(/*! @babel/runtime/helpers/possibleConstructorReturn */ "./node_modules/@babel/runtime/helpers/possibleConstructorReturn.js"));var _getPrototypeOf2=_interopRequireDefault(__webpack_require__(/*! @babel/runtime/helpers/getPrototypeOf */ "./node_modules/@babel/runtime/helpers/getPrototypeOf.js"));var _rteControllerBase=__webpack_require__(/*! @agora-rte/rte-controller-base */ "./node_modules/@agora-rte/rte-controller-base/lib/index.js");var _react=_interopRequireDefault(__webpack_require__(/*! react */ "react"));var _remote_component=__webpack_require__(/*! ./components/remote_component */ "./src/components/remote_component.tsx");function _createSuper(Derived){var hasNativeReflectConstruct=_isNativeReflectConstruct();return function _createSuperInternal(){var Super=(0,_getPrototypeOf2.default)(Derived),result;if(hasNativeReflectConstruct){var NewTarget=(0,_getPrototypeOf2.default)(this).constructor;result=Reflect.construct(Super,arguments,NewTarget);}else{result=Super.apply(this,arguments);}return(0,_possibleConstructorReturn2.default)(this,result);};}function _isNativeReflectConstruct(){if(typeof Reflect==="undefined"||!Reflect.construct)return false;if(Reflect.construct.sham)return false;if(typeof Proxy==="function")return true;try{Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],function(){}));return true;}catch(e){return false;}}var __awaiter=this&&this.__awaiter||function(thisArg,_arguments,P,generator){function adopt(value){return value instanceof P?value:new P(function(resolve){resolve(value);});}return new(P||(P=Promise))(function(resolve,reject){function fulfilled(value){try{step(generator.next(value));}catch(e){reject(e);}}function rejected(value){try{step(generator["throw"](value));}catch(e){reject(e);}}function step(result){result.done?resolve(result.value):adopt(result.value).then(fulfilled,rejected);}step((generator=generator.apply(thisArg,_arguments||[])).next());});};var ExtensionContainer=function(_React$Component){(0,_inherits2.default)(ExtensionContainer,_React$Component);var _super=_createSuper(ExtensionContainer);function ExtensionContainer(props){var _this;(0,_classCallCheck2.default)(this,ExtensionContainer);_this=_super.call(this,props);_this.state={isReady:false};if(_this.props.rteContext.rteUiWidgetList){var matchedWidget=_this.props.rteContext.rteUiWidgetList.widgets.find(function(widgetInfo){if(_this.props.extensionGroup&&_this.props.extensionGroup!==widgetInfo.extension_group){return false;}return widgetInfo.extension===_this.props.extension;});if(!matchedWidget){throw new Error("No widget found by extension "+_this.props.extension);}_this.props.rteContext.submitProfilingEvent(matchedWidget.extension,matchedWidget.extension_group,'render-extension-container');if(!matchedWidget.propsFromExtension){matchedWidget.propsFromExtension={};}if(_this.props.widgetProps){Object.assign(matchedWidget.propsFromExtension,_this.props.widgetProps);}_this.widgetInfo=matchedWidget;}return _this;}(0,_createClass2.default)(ExtensionContainer,[{key:"componentDidMount",value:function componentDidMount(){return __awaiter(this,void 0,void 0,function*(){if(this.widgetInfo){var props=yield(0,_rteControllerBase.getWidgetPropsFromExtension)(this.props.rteContext,this.widgetInfo);Object.assign(this.widgetInfo.propsFromExtension,props);this.setState({isReady:true});}});}},{key:"render",value:function render(){var _a,_b;if(!this.widgetInfo){return _react.default.createElement(_react.default.Fragment,null,"No ui widget info.");}if(!this.state.isReady){return _react.default.createElement(_react.default.Fragment,null);}var renderLocalComp=(_b=(_a=this.props.options)===null||_a===void 0?void 0:_a.localComps)===null||_b===void 0?void 0:_b.get(this.props.extension);if(renderLocalComp){return renderLocalComp({rteContext:this.props.rteContext,rteUiWidgetInfo:this.widgetInfo});}return _react.default.createElement(_remote_component.RemoteComponent,{rteContext:this.props.rteContext,options:this.props.options,rteUiWidgetInfo:this.widgetInfo});}}]);return ExtensionContainer;}(_react.default.Component);exports.ExtensionContainer=ExtensionContainer;

/***/ }),

/***/ "react-native":
/*!*******************************!*\
  !*** external "react-native" ***!
  \*******************************/
/***/ ((module) => {

"use strict";
module.exports = __WEBPACK_EXTERNAL_MODULE_react_native__;

/***/ }),

/***/ "react":
/*!************************************************************************!*\
  !*** external {"commonjs":"react","commonjs2":"react","root":"React"} ***!
  \************************************************************************/
/***/ ((module) => {

"use strict";
module.exports = __WEBPACK_EXTERNAL_MODULE_react__;

/***/ }),

/***/ "./node_modules/@babel/runtime/helpers/arrayLikeToArray.js":
/*!*****************************************************************!*\
  !*** ./node_modules/@babel/runtime/helpers/arrayLikeToArray.js ***!
  \*****************************************************************/
/***/ ((module) => {

function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length) len = arr.length;

  for (var i = 0, arr2 = new Array(len); i < len; i++) {
    arr2[i] = arr[i];
  }

  return arr2;
}

module.exports = _arrayLikeToArray, module.exports.__esModule = true, module.exports["default"] = module.exports;

/***/ }),

/***/ "./node_modules/@babel/runtime/helpers/arrayWithHoles.js":
/*!***************************************************************!*\
  !*** ./node_modules/@babel/runtime/helpers/arrayWithHoles.js ***!
  \***************************************************************/
/***/ ((module) => {

function _arrayWithHoles(arr) {
  if (Array.isArray(arr)) return arr;
}

module.exports = _arrayWithHoles, module.exports.__esModule = true, module.exports["default"] = module.exports;

/***/ }),

/***/ "./node_modules/@babel/runtime/helpers/arrayWithoutHoles.js":
/*!******************************************************************!*\
  !*** ./node_modules/@babel/runtime/helpers/arrayWithoutHoles.js ***!
  \******************************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var arrayLikeToArray = __webpack_require__(/*! ./arrayLikeToArray.js */ "./node_modules/@babel/runtime/helpers/arrayLikeToArray.js");

function _arrayWithoutHoles(arr) {
  if (Array.isArray(arr)) return arrayLikeToArray(arr);
}

module.exports = _arrayWithoutHoles, module.exports.__esModule = true, module.exports["default"] = module.exports;

/***/ }),

/***/ "./node_modules/@babel/runtime/helpers/assertThisInitialized.js":
/*!**********************************************************************!*\
  !*** ./node_modules/@babel/runtime/helpers/assertThisInitialized.js ***!
  \**********************************************************************/
/***/ ((module) => {

function _assertThisInitialized(self) {
  if (self === void 0) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }

  return self;
}

module.exports = _assertThisInitialized, module.exports.__esModule = true, module.exports["default"] = module.exports;

/***/ }),

/***/ "./node_modules/@babel/runtime/helpers/classCallCheck.js":
/*!***************************************************************!*\
  !*** ./node_modules/@babel/runtime/helpers/classCallCheck.js ***!
  \***************************************************************/
/***/ ((module) => {

function _classCallCheck(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
}

module.exports = _classCallCheck, module.exports.__esModule = true, module.exports["default"] = module.exports;

/***/ }),

/***/ "./node_modules/@babel/runtime/helpers/createClass.js":
/*!************************************************************!*\
  !*** ./node_modules/@babel/runtime/helpers/createClass.js ***!
  \************************************************************/
/***/ ((module) => {

function _defineProperties(target, props) {
  for (var i = 0; i < props.length; i++) {
    var descriptor = props[i];
    descriptor.enumerable = descriptor.enumerable || false;
    descriptor.configurable = true;
    if ("value" in descriptor) descriptor.writable = true;
    Object.defineProperty(target, descriptor.key, descriptor);
  }
}

function _createClass(Constructor, protoProps, staticProps) {
  if (protoProps) _defineProperties(Constructor.prototype, protoProps);
  if (staticProps) _defineProperties(Constructor, staticProps);
  Object.defineProperty(Constructor, "prototype", {
    writable: false
  });
  return Constructor;
}

module.exports = _createClass, module.exports.__esModule = true, module.exports["default"] = module.exports;

/***/ }),

/***/ "./node_modules/@babel/runtime/helpers/defineProperty.js":
/*!***************************************************************!*\
  !*** ./node_modules/@babel/runtime/helpers/defineProperty.js ***!
  \***************************************************************/
/***/ ((module) => {

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}

module.exports = _defineProperty, module.exports.__esModule = true, module.exports["default"] = module.exports;

/***/ }),

/***/ "./node_modules/@babel/runtime/helpers/getPrototypeOf.js":
/*!***************************************************************!*\
  !*** ./node_modules/@babel/runtime/helpers/getPrototypeOf.js ***!
  \***************************************************************/
/***/ ((module) => {

function _getPrototypeOf(o) {
  module.exports = _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) {
    return o.__proto__ || Object.getPrototypeOf(o);
  }, module.exports.__esModule = true, module.exports["default"] = module.exports;
  return _getPrototypeOf(o);
}

module.exports = _getPrototypeOf, module.exports.__esModule = true, module.exports["default"] = module.exports;

/***/ }),

/***/ "./node_modules/@babel/runtime/helpers/inherits.js":
/*!*********************************************************!*\
  !*** ./node_modules/@babel/runtime/helpers/inherits.js ***!
  \*********************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var setPrototypeOf = __webpack_require__(/*! ./setPrototypeOf.js */ "./node_modules/@babel/runtime/helpers/setPrototypeOf.js");

function _inherits(subClass, superClass) {
  if (typeof superClass !== "function" && superClass !== null) {
    throw new TypeError("Super expression must either be null or a function");
  }

  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      writable: true,
      configurable: true
    }
  });
  Object.defineProperty(subClass, "prototype", {
    writable: false
  });
  if (superClass) setPrototypeOf(subClass, superClass);
}

module.exports = _inherits, module.exports.__esModule = true, module.exports["default"] = module.exports;

/***/ }),

/***/ "./node_modules/@babel/runtime/helpers/interopRequireDefault.js":
/*!**********************************************************************!*\
  !*** ./node_modules/@babel/runtime/helpers/interopRequireDefault.js ***!
  \**********************************************************************/
/***/ ((module) => {

function _interopRequireDefault(obj) {
  return obj && obj.__esModule ? obj : {
    "default": obj
  };
}

module.exports = _interopRequireDefault, module.exports.__esModule = true, module.exports["default"] = module.exports;

/***/ }),

/***/ "./node_modules/@babel/runtime/helpers/iterableToArray.js":
/*!****************************************************************!*\
  !*** ./node_modules/@babel/runtime/helpers/iterableToArray.js ***!
  \****************************************************************/
/***/ ((module) => {

function _iterableToArray(iter) {
  if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter);
}

module.exports = _iterableToArray, module.exports.__esModule = true, module.exports["default"] = module.exports;

/***/ }),

/***/ "./node_modules/@babel/runtime/helpers/iterableToArrayLimit.js":
/*!*********************************************************************!*\
  !*** ./node_modules/@babel/runtime/helpers/iterableToArrayLimit.js ***!
  \*********************************************************************/
/***/ ((module) => {

function _iterableToArrayLimit(arr, i) {
  var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"];

  if (_i == null) return;
  var _arr = [];
  var _n = true;
  var _d = false;

  var _s, _e;

  try {
    for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) {
      _arr.push(_s.value);

      if (i && _arr.length === i) break;
    }
  } catch (err) {
    _d = true;
    _e = err;
  } finally {
    try {
      if (!_n && _i["return"] != null) _i["return"]();
    } finally {
      if (_d) throw _e;
    }
  }

  return _arr;
}

module.exports = _iterableToArrayLimit, module.exports.__esModule = true, module.exports["default"] = module.exports;

/***/ }),

/***/ "./node_modules/@babel/runtime/helpers/nonIterableRest.js":
/*!****************************************************************!*\
  !*** ./node_modules/@babel/runtime/helpers/nonIterableRest.js ***!
  \****************************************************************/
/***/ ((module) => {

function _nonIterableRest() {
  throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}

module.exports = _nonIterableRest, module.exports.__esModule = true, module.exports["default"] = module.exports;

/***/ }),

/***/ "./node_modules/@babel/runtime/helpers/nonIterableSpread.js":
/*!******************************************************************!*\
  !*** ./node_modules/@babel/runtime/helpers/nonIterableSpread.js ***!
  \******************************************************************/
/***/ ((module) => {

function _nonIterableSpread() {
  throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}

module.exports = _nonIterableSpread, module.exports.__esModule = true, module.exports["default"] = module.exports;

/***/ }),

/***/ "./node_modules/@babel/runtime/helpers/possibleConstructorReturn.js":
/*!**************************************************************************!*\
  !*** ./node_modules/@babel/runtime/helpers/possibleConstructorReturn.js ***!
  \**************************************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var _typeof = (__webpack_require__(/*! ./typeof.js */ "./node_modules/@babel/runtime/helpers/typeof.js")["default"]);

var assertThisInitialized = __webpack_require__(/*! ./assertThisInitialized.js */ "./node_modules/@babel/runtime/helpers/assertThisInitialized.js");

function _possibleConstructorReturn(self, call) {
  if (call && (_typeof(call) === "object" || typeof call === "function")) {
    return call;
  } else if (call !== void 0) {
    throw new TypeError("Derived constructors may only return object or undefined");
  }

  return assertThisInitialized(self);
}

module.exports = _possibleConstructorReturn, module.exports.__esModule = true, module.exports["default"] = module.exports;

/***/ }),

/***/ "./node_modules/@babel/runtime/helpers/setPrototypeOf.js":
/*!***************************************************************!*\
  !*** ./node_modules/@babel/runtime/helpers/setPrototypeOf.js ***!
  \***************************************************************/
/***/ ((module) => {

function _setPrototypeOf(o, p) {
  module.exports = _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) {
    o.__proto__ = p;
    return o;
  }, module.exports.__esModule = true, module.exports["default"] = module.exports;
  return _setPrototypeOf(o, p);
}

module.exports = _setPrototypeOf, module.exports.__esModule = true, module.exports["default"] = module.exports;

/***/ }),

/***/ "./node_modules/@babel/runtime/helpers/slicedToArray.js":
/*!**************************************************************!*\
  !*** ./node_modules/@babel/runtime/helpers/slicedToArray.js ***!
  \**************************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var arrayWithHoles = __webpack_require__(/*! ./arrayWithHoles.js */ "./node_modules/@babel/runtime/helpers/arrayWithHoles.js");

var iterableToArrayLimit = __webpack_require__(/*! ./iterableToArrayLimit.js */ "./node_modules/@babel/runtime/helpers/iterableToArrayLimit.js");

var unsupportedIterableToArray = __webpack_require__(/*! ./unsupportedIterableToArray.js */ "./node_modules/@babel/runtime/helpers/unsupportedIterableToArray.js");

var nonIterableRest = __webpack_require__(/*! ./nonIterableRest.js */ "./node_modules/@babel/runtime/helpers/nonIterableRest.js");

function _slicedToArray(arr, i) {
  return arrayWithHoles(arr) || iterableToArrayLimit(arr, i) || unsupportedIterableToArray(arr, i) || nonIterableRest();
}

module.exports = _slicedToArray, module.exports.__esModule = true, module.exports["default"] = module.exports;

/***/ }),

/***/ "./node_modules/@babel/runtime/helpers/toConsumableArray.js":
/*!******************************************************************!*\
  !*** ./node_modules/@babel/runtime/helpers/toConsumableArray.js ***!
  \******************************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var arrayWithoutHoles = __webpack_require__(/*! ./arrayWithoutHoles.js */ "./node_modules/@babel/runtime/helpers/arrayWithoutHoles.js");

var iterableToArray = __webpack_require__(/*! ./iterableToArray.js */ "./node_modules/@babel/runtime/helpers/iterableToArray.js");

var unsupportedIterableToArray = __webpack_require__(/*! ./unsupportedIterableToArray.js */ "./node_modules/@babel/runtime/helpers/unsupportedIterableToArray.js");

var nonIterableSpread = __webpack_require__(/*! ./nonIterableSpread.js */ "./node_modules/@babel/runtime/helpers/nonIterableSpread.js");

function _toConsumableArray(arr) {
  return arrayWithoutHoles(arr) || iterableToArray(arr) || unsupportedIterableToArray(arr) || nonIterableSpread();
}

module.exports = _toConsumableArray, module.exports.__esModule = true, module.exports["default"] = module.exports;

/***/ }),

/***/ "./node_modules/@babel/runtime/helpers/typeof.js":
/*!*******************************************************!*\
  !*** ./node_modules/@babel/runtime/helpers/typeof.js ***!
  \*******************************************************/
/***/ ((module) => {

function _typeof(obj) {
  "@babel/helpers - typeof";

  return (module.exports = _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) {
    return typeof obj;
  } : function (obj) {
    return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
  }, module.exports.__esModule = true, module.exports["default"] = module.exports), _typeof(obj);
}

module.exports = _typeof, module.exports.__esModule = true, module.exports["default"] = module.exports;

/***/ }),

/***/ "./node_modules/@babel/runtime/helpers/unsupportedIterableToArray.js":
/*!***************************************************************************!*\
  !*** ./node_modules/@babel/runtime/helpers/unsupportedIterableToArray.js ***!
  \***************************************************************************/
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {

var arrayLikeToArray = __webpack_require__(/*! ./arrayLikeToArray.js */ "./node_modules/@babel/runtime/helpers/arrayLikeToArray.js");

function _unsupportedIterableToArray(o, minLen) {
  if (!o) return;
  if (typeof o === "string") return arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor) n = o.constructor.name;
  if (n === "Map" || n === "Set") return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return arrayLikeToArray(o, minLen);
}

module.exports = _unsupportedIterableToArray, module.exports.__esModule = true, module.exports["default"] = module.exports;

/***/ })

/******/ 	});
/************************************************************************/
/******/ 	// The module cache
/******/ 	var __webpack_module_cache__ = {};
/******/ 	
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/ 		// Check if module is in cache
/******/ 		var cachedModule = __webpack_module_cache__[moduleId];
/******/ 		if (cachedModule !== undefined) {
/******/ 			return cachedModule.exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = __webpack_module_cache__[moduleId] = {
/******/ 			// no module.id needed
/******/ 			// no module.loaded needed
/******/ 			exports: {}
/******/ 		};
/******/ 	
/******/ 		// Execute the module function
/******/ 		__webpack_modules__[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/ 	
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/ 	
/************************************************************************/
/******/ 	/* webpack/runtime/global */
/******/ 	(() => {
/******/ 		__webpack_require__.g = (function() {
/******/ 			if (typeof globalThis === 'object') return globalThis;
/******/ 			try {
/******/ 				return this || new Function('return this')();
/******/ 			} catch (e) {
/******/ 				if (typeof window === 'object') return window;
/******/ 			}
/******/ 		})();
/******/ 	})();
/******/ 	
/************************************************************************/
/******/ 	
/******/ 	// startup
/******/ 	// Load entry module and return exports
/******/ 	// This entry module is referenced by other modules so it can't be inlined
/******/ 	var __webpack_exports__ = __webpack_require__("./src/extension_container.tsx");
/******/ 	
/******/ 	return __webpack_exports__;
/******/ })()
;
});
//# sourceMappingURL=extension_container.js.map