/**
 *
 * Agora Real Time Engagement
 * Created by Wei Hu in 2022-05.
 * Copyright (c) 2022 Agora IO. All rights reserved.
 *
 */
declare type ModuleContent = Record<string, any>;
declare type ModuleContentGenerator = () => ModuleContent;
export declare type ModulesContentGenerator = Record<string, ModuleContentGenerator>;
interface CjsModule {
    exports: ModuleContent;
}
export interface EsModule {
    default: ModuleContent;
}
declare type CjsModuleGenerator = () => CjsModule;
export declare type CjsModulesGenerator = Record<string, CjsModuleGenerator>;
export declare function getModuleContent(code_text: string, moduleName: string, modulesDependsOn: CjsModulesGenerator): ModuleContent;
export declare function getCjsModules(modulesContentGenerator: ModulesContentGenerator): CjsModulesGenerator;
export {};
