/**
 *
 * Agora Real Time Engagement
 * Created by Liu Loulou in 2022-06.
 * Copyright (c) 2022 Agora IO. All rights reserved.
 *
 */
import { RteContext, RteUiWidgetInfo } from '@agora-rte/rte-controller-base';
import React from 'react';
import { RteLayoutRenderOptions } from './ui_widget';
interface ExtensionContainerProps {
    rteContext: RteContext;
    extension: string;
    extensionGroup?: string;
    options?: RteLayoutRenderOptions;
    widgetProps?: Record<string, unknown>;
}
interface ExtensionContainerState {
    isReady: boolean;
}
export declare class ExtensionContainer extends React.Component<ExtensionContainerProps, ExtensionContainerState> {
    constructor(props: ExtensionContainerProps);
    componentDidMount(): Promise<void>;
    render(): React.ReactNode;
    widgetInfo?: RteUiWidgetInfo;
}
export {};
